#!/usr/bin/perl
#----------------------------------------------------------------------------#
#                                                                            #
# dbttm_admin.cgi    Version 2.0 Lite                                        #
#                                                                            #
#                       						     #
# Database version of the talktome script                                    #
# Inspired by the TalkToMe.cgi written by Sue Braiden			     #
#                                                                            #
# Written by: Brian Helle  webmaster@expertsolutions.net                     #
# Date Released: 2/14/2000                                                   #
#                                                                            #
# Description:	Forum Management tool for db_TalkToMe V2 Lite                #
#		More information and the FULL version available              #
#		at www.expertsolutions.net                      	     #
#									     #
# Required files:							     #
#			db_TalkToMe.cgi					     #
#			dbttm_admin.cgi					     #
#			main_forum.setup.cgi  				     #
#			date.pl         				     #
#			cgi-lib.pl      				     #
#----------------------------------------------------------------------------#

#----------------------------------------------------------------------------#
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 Brian Helle   All Rights Reserved.                          #
#                                                                            #
# This program may be used free of charge by anyone so long as               #
# the following requirements are met.                                        #
# This copyright notice, and all comments remain intact.                     #
# The link back to me remains intact in the footer section of all pages.     #
#                                                                            #
# By using this code you agree to indemnify Brian Helle from any liability   #
# that might arise from it's use.                                            #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
#                                                                            #
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United States of America.                        #
#----------------------------------------------------------------------------#

#----------------------------------------------------------------------------#
# Acknowledgments:                                                           #
#                                                                            #
# The following people have had significant impact on this project.          #
# Sue Braiden: Author of the original TalkToMe script.                       #
# Calle Johannesson: Original artwork and inspiration.                       #
# Chris Hunt: Author of the function random_password()                       #
# Last, but in no way least, AnnaMary Helle, my wife.                        #
#	For listening to me ramble on and on about code and checking and     #
#	re-checking the program -- Thank you.                                #
#----------------------------------------------------------------------------#

do "./_login-b.pl";
#do "./_ismaintutor-lynx.pl";
do "./_ischieftutor-b.pl";

# load main configuration if not already loaded
if(!$CONFIG_LOADED) {
    do "./_conf-b.rc";
}

# function lineInFile is defined in _istutor-b.pl or _ischieftutor-b.pl
$loginid=$cgi->cookie(-name=>'loginid');
$unitShortName=$cgi->cookie(-name=>'unitshortname');



print "Content-type: text/html\n\n";

# REQUIRE LIBRARY FILES
# No need to edit these
# require ("cgi-lib.pl") || die ("Cant require cgi-lib.pl");
require ("date.pl") || die ("Cant require date.pl");
require ("_forum.rc") || die ("Cant require Forum setup file");
# &ReadParse(*form_data);
use CGI;
CGI::ReadParse(*form_data);

# USER CONFIG
# YOU MUST SET THE FOLLOWING VARIABLES TO YOUR SPECIFIC SERVER.
$date_command = "/bin/date";
$mail_program = "/usr/lib/sendmail -t -n";
$databoard_url ="${scriptprotocol}://staff.scm.uws.edu.au/cgi-bin/cgiwrap/zhuhan/forum/forum.pl";
$base_url = "${scriptprotocol}://staff.scm.uws.edu.au/cgi-bin/cgiwrap/zhuhan/forum/editforum.pl";
$icon_path="$webhomesite/cgi-bin/forum/images/";
$detail_bg_color = "#CCFFFF"; # set the color of the background in the detail message table
#$background_image = "/~zhuhan/cgi-bin/images/gp_white.gif";
$background_image = "${icon_path}/gp_white.gif";
$title = "db_TalkToMe V2 Manager LITE ";



##############################################################
# NO NEED TO EDIT ANYTHING BELOW THIS LINE

# set the default data
$index_record = "data/${unitShortName}_forum";

# SET THE DATE IN A VARIABLE
# This date command allows for Y2K compliance. The year is 4 digits
$shortdate = `$date_command +"%m/%d/%Y %T %Z"`;
chop($shortdate);



########################
# Program Flow

if ($form_data{'options'} eq "reports") {
	&reports;
	exit;
 	}
if ($form_data{'options'} eq "new") {
	&feature_notification;
	exit;
 	}
if ($form_data{'options'} eq "modify") {
	&database_selection;
	exit;
 	}
if ($form_data{'options'} eq "search") {
	&feature_notification;
	exit;
	}
if ($form_data{'options'} eq "account") {
	&feature_notification;
	exit;
	}
if ($form_data{'options'} eq "register") {
	&register;
	exit;
	}
if ($form_data{'mode'} eq "view_forum") {
	&message_display_all;
	exit;
 	}
if ($form_data{'mode'} eq "update") {
	&show_message;
	exit;
	}
if ($form_data{'mode'} eq "update_record") {
	&update_record;
	exit;
	}
if ($form_data{'mode'} eq "delete_record") {
	&delete_record;
	exit;
	}
if ($form_data{'mode'} eq "view") {
	&view_message;
	exit;
	}

&control_page;
exit;
#----------------#
# End of program #
#----------------#

#-----------#
# Functions #
#-----------#

#-------------------------------#
# This is the main control page #
#-------------------------------#
sub control_page
  {

# Start the control panel html
print qq~
<html>
<head>
<title>$title</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=0 cellspacing=0 width=480 border=0 bgcolor="#000000">
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Administration Control Panel LITE</u></h2></font></td></tr>
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
	Not all features are available on the Lite version.<br>
	Full version available at www.expertsolutions.net<br><br></font></td></tr>
<tr><td colspan=2 bgcolor="#FFFFE0" align="right"><font face="Verdana">
	Number of Forums: &nbsp;1&nbsp;&nbsp;<br>&nbsp;</font></td></tr>
<tr><td align="center" width="50%" bgcolor="#E6E6FA"><font face="Verdana"><b>Functions</b><br><hr noshade width="90%"></font></td>
    <td align="center" bgcolor="#FFE4C4"><font face="Verdana"><b>Accounts</b><br><hr noshade width="90%"></font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana">
	<br>
	<a href="$base_url?options=reports">Reports</a><br><br>
	<a href="$base_url?options=new">New Forum</a><br><br>
	<a href="$base_url?options=modify">View/Edit Forum</a><br><br>
	<a href="$base_url?options=search">Power Search</a><br><br></font></td>
    <td align="center" bgcolor="#FFE4C4"><font face="Verdana">
        <br>
        0 Pending requests<br>
        <a href="$base_url?options=account">Process</a><br><br>
        Current Accounts: 0 <br>
        <hr noshade width="90%">
        <b>Manage Accounts</b><br>
        <br>
        <a href="$base_url?options=account">List All</a>
        <br>&nbsp;</font></td></tr>
</table>
</td></tr></table>
<font face="Verdana" size="-2">Program by: <a href="mailto:webmaster\@expertsolutions.net">Brian Helle</a><br>
<a href="$base_url?options=register">Registration Information</a><br></font>
</center>

</body>
</html>
~;
}# end control panel



#------------------------------------------------------------------------------#
# load_datafile                                                                #
# Takes a file name as an argument and returns an array with the file contents #
# Modified 8/10/99 to allow for blank lines, also creates a new array of the   #
# comment lines for easier updating of a file.                                 #
#------------------------------------------------------------------------------#
sub load_datafile
  {
local ($file_to_get) = @_;
local ($line);
local (@clean_records);
print ("<br>Can't open $file_to_get \n") unless (open(DATAFILE, "$file_to_get"));
flock(DATAFILE, 2);
  @all = <DATAFILE>;
flock(DATAFILE, 8);
close(DATAFILE);
$rec_count = 0;
# set the comment records in it's own list
foreach (@all) {
	if ($_ =~ /^COMMENT:/) {
		push(@comment_records, $_);
	}
}
# Strip out any comments or blank lines
foreach $line (@all) {
	if ($line !~ /^COMMENT:/ && $line ne "\n") {
		push(@clean_records, $line);
		$rec_count++;
	} # end if
} # end foreach
if ($rec_count == 0) {
	push(@clean_records, "none");
}

return (@clean_records);
} # end function



#-----------------------------------------------#
# Reports function                              #
# Outputs details on all of the current forums. #
#-----------------------------------------------#
sub reports
  {
# Start the output
print qq~
<html><head><title>Administration Reports</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=5 cellspacing=0 width=600 border=0 bgcolor="#000000">
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Administration Reports</u></h2></font></td></tr>
~;

# Get the number of forums
if (-e "$data_file_path") {
	$number_of_forums = 1;
} else {
	# No forums, report this to the user
	print qq~
	<tr><td colspan=6 bgcolor="#E6E6FA" align="center"><font face="Verdana" size=3>
	    <br>
	    The Forum is currently empty.
	    <br>&nbsp;</font>
	    </td></tr>
	<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
            <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
            </td></tr>
        </table></td></tr></table></center></body></html>
	~;
	exit;
}

print qq~
<tr><td colspan=6 bgcolor="#FFFFE0" align="right"><font face="Verdana" size=2>
	Number of Forums: &nbsp;$number_of_forums&nbsp;&nbsp;<br>&nbsp;</font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Forum Name</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Access</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Total<br>Messages</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>File Size</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Days in<br>Opperation</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Last Entry<br>Date</b></font></td></tr>

~;

$todays_j_day = &today();

	$accessis = "Public";

	# create the data file name from the information
	$dfile = "$index_record.data";
	$filesizeK = int((-s $dfile) / 1000);
	if ($filesizeK <= 0) {
		$filesizeK = "< 1";
	}
	@forum_records = &load_datafile($dfile);
	$todays_j_day = &today();
if ($forum_records[0] ne "none") {
	$total_messages = @forum_records;
	@rec_fields = split(/\|/, $forum_records[0]);
	@date_parts = split(/ /, $rec_fields[1]);
	@just_the_date = split(/\//, $date_parts[0]);
	$first_date = &jday($just_the_date[0],$just_the_date[1],$just_the_date[2]);
	@last_rec_fields = split(/\|/, $forum_records[$total_messages - 1]);
	@last_date = split(/ /, $last_rec_fields[1]);
	$total_days = ($todays_j_day - $first_date);
} else {
	$total_messages = "NONE";
	$last_date[0] = "NONE";
	$total_days = "NONE";
}

print qq~
<tr><td colspan=6 bgcolor="#E6E6FA" align="right"><hr noshade></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <a href="$databoard_url" target="_blank">$forum_name</a></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    $accessis</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    $total_messages</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    $filesizeK K</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    $total_days</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    $last_date[0]</font></td></tr>

~;

print qq~
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <a href="$base_url?options=register">Registration Information</a><br>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;

} # end reports function

#-----------------------------------------------------------------#
# Feature Notification                                            #
# Outputs details the features not available on the lite version. #
#-----------------------------------------------------------------#
sub feature_notification
  {
# Start the output
print qq~
<html><head><title>Administration Feature Notification</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=5 cellspacing=0 width=600 border=0 bgcolor="#000000">
<tr><td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Administration Feature Notification</u></h2></font></td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="right"><font face="Verdana" size=2>
	The selected option is not available on the LITE version.<br>
	The following is a brief introduction to these features.<br></font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>New Forum</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    The "New Forum" option allows you to create an unlimited number of forums.
    After prompting you for some initial information the program will automatically
    set up your new forum. After your new forum is created you can then further
    customize the look and feel to blend in with your current web design. Forums
    can be designated as either public or private. Private boards utilize user
    accounts for protection.
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Power Search</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    The "Power Search" option gives the administrator global search capabilities.
    As the administrator, you are able to search All Forums, All Public,
    All Private or specifically select a forum to search. Group searches
    quickly find the desired information and format the results by each
    forum. This allows you to determine what forum contains the information
    you want and gives you the ability to view the specific message.
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Accounts</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    The "Accounts" section of the control panel allows the administrator to
    manage all aspects of User Accounts. Pending accounts are created when
    a new user signs up for a private forum that requires administration
    approval before they can enter the forum. Private forums can also be setup
    to allow for automatic approval. The "List All" option allows you to
    review all the user account details and suspend or restore them as needed.
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Security</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Registering this program gives you complete user ID / Password protection
    for both the administration program and private forums. Private forum user
    accounts streamline the registration process by automatically assigning
    user passwords and verifying each account is unique. By assigning user
    passwords, malicious attacks are minimized by requiring a valid e-mail
    address before access is granted.
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Version 1</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Although version 1 and version 2 are very different internally, version
    2 has the ability to automatically convert your current version 1 forums
    to the new version 2 format. Want to convert your version 1 forums to list
    the newest message on top?
    <a href="http://www.expertsolutions.net/scripts/register.html">Register version 2</a> and it's easy.
    </font></td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <br><a href="$base_url?options=register">Registration Information</a><br>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;

} # end feature notification

#-----------------------------------------------------------------#
# Registration Information                                        #
#-----------------------------------------------------------------#
sub register
  {
# Start the output
print qq~
<html><head><title>Version 2 Registration</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=5 cellspacing=0 width=600 border=0 bgcolor="#000000">
<tr><td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td>
    <td width=100 bgcolor="#FFFFE0">&nbsp; </td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Version 2 Registration</u></h2></font></td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="right"><font face="Verdana" size=2>
	&nbsp;<br></font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Benifits</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <ul>
        <li>Full Security control
        <li>User Accounts
        <li>Global search ability
        <li>Unlimited number of forums
        <li>FREE minor updates / patches / fixes
        <li>Discounted major upgrades
        <li>Instalation and Usage support
    </ul>
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Registration</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Use the following link to the registration form.<br>
    <a href="http://www.expertsolutions.net/scripts/register.html">Register Version 2</a>,<br>
    </font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" colspan=6><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Payment</b></font></td>
    <td align="left" colspan=5 bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Send a <u>check</u> or <u>money order</u> for &#036;30.00 US Dollars payable to<br>
    Brian Helle<br>
    100 Cerasi Dr. Suite 420<br>
    Pittsburgh, PA. 15122<br>
    <br>
    <b>Money Orders</b> - The same day I receive the money order you will receive
    db_TalkToMe Version 2.<br>
    <b>Checks</b> - Checks require a 10 to 14 day period to clear the bank from
    the day I receive payment. As soon as your check is confirmed, you will receive
    db_TalkToMe Version 2.<br>
    </font></td></tr>
<tr><td colspan=6 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;

} # end registration

#---------------------------------#
# Modify Forum database selection #
#---------------------------------#
sub database_selection
  {
# Start the output
print qq~
<html><head><title>Administration Modify a Forum</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=5 cellspacing=0 width=600 border=0 bgcolor="#000000">
<tr><td colspan=3 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Administration Modify</u></h2></font></td></tr>
~;
# Get the number of forums
if (-e "$data_file_path") {
	$number_of_forums = 1;
} else {
	# No forums, report this to the user
	print qq~
	<tr><td colspan=3 bgcolor="#E6E6FA" align="center"><font face="Verdana" size=3>
	    <br>
	    The Forum is currently empty.
	    <br>&nbsp;</font>
	    </td></tr>
    	<tr><td colspan=3 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
            <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
            </td></tr>
        </table></td></tr></table></center></body></html>
	~;
	exit;
}
print qq~
<tr><td colspan=3 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
	Please select the forum you wish to edit messages in.<br>&nbsp;</font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Forum Name</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Access</b></font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <b>Description</b></font></td></tr>
~;
		$accessis = "Public";

	$dfile = "$index_record.data";
	$sfile = "_forum.rc";  # "$index_record.setup.cgi";
	print qq~
	<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
	<FORM METHOD="post" ACTION="$base_url">
	<INPUT TYPE="hidden" NAME="mode" VALUE="view_forum">
	<INPUT TYPE="hidden" NAME="ffile" VALUE="$dfile">
	<INPUT TYPE="hidden" NAME="sfile" VALUE="$sfile">
	<INPUT TYPE="submit" VALUE="$index_record"></font></form></td>
	<td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
	$accessis</font></td>
	<td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
	$forum_desc</font></td></tr>
	<tr><td align="center" bgcolor="#E6E6FA" colspan=3><hr noshade width="90%"></td></tr>
	~;

print qq~
<tr><td colspan=3 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <a href="$base_url?options=register">Registration Information</a><br>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;
} # End Database selection function


#--------------------------------------------#
# Output a threaded list of all the messages #
#--------------------------------------------#
sub message_display_all
  {
# Start the output
print qq~
<html><head><title>Administration Modify a Forum</title>
</head>
<body background="$background_image">
<font face="Verdana" size=2>
<center>
<h2>Administration Mode</h2>
~;
# Get all of the messages
@all_messages = &load_datafile($form_data{'ffile'});
# See if the data file is empty, if so, report this and exit

if ($all_messages[0] eq "none") {
	print qq~
	<center>
	<table border=1 bgcolor="#FFFFE0" width="200">
	<tr><td><font face="Verdana" size=2><b>There are no messages</b></font></td></tr>
	<tr><td bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
	    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
	</table></center></body></html>
	~;
	exit;
}
# Set up an ordered list of messages and the parent messages
foreach (@all_messages) {
	@message_fields = split(/\|/, $_);
	$ordered_messages[$message_fields[0]] = $_;
	if ($message_fields[11] eq "" ) {
		# record has no parent
	  	push (@parent_messages, $_);
	}
}

# Start the message table
print qq~
<table border=1 bgcolor="#FFEBCD" width="95%">
<tr><td bgcolor="#FFEBCD"><font face="Verdana" size=2><ul>
~;
# Listing ordered oldest to newest.
if ($display_order == 1) {
	foreach (@parent_messages) {
		@pr_fields = split(/\|/, $_);
		print qq~
		<li>
		<img src="$icon_path$pr_fields[7]">
<a href="$base_url?file=$form_data{'ffile'}&mode=update&message_number=$pr_fields[0]">$pr_fields[4]</a>
 - <b>$pr_fields[2]</b> $pr_fields[1] ($pr_fields[13])<br>
~;
		if ($pr_fields[12] ne "") { # this record has children
		  @list_to_send = split(/,/, $pr_fields[12]);
		  &print_all_children(@list_to_send);
		}
	}
} else {

	for ($i = $#parent_messages; $i >= 0; $i--) {
		@pr_fields = split(/\|/, $parent_messages[$i]);
		print qq~
		<li>
		<img src="$icon_path$pr_fields[7]">
<a href="$base_url?file=$form_data{'ffile'}&mode=update&message_number=$pr_fields[0]">$pr_fields[4]</a>
 - <b>$pr_fields[2]</b> $pr_fields[1] ($pr_fields[13])<br>
~;
		if ($pr_fields[12] ne "") { # this record has children
		  @list_to_send = split(/,/, $pr_fields[12]);
		  &print_all_children(@list_to_send);
		}
	}

}

$tm = $#all_messages + 1;
print qq~
</ul><br>&nbsp;</font></td></tr>
<td bgcolor="#FFEBCD" align="center"><font face="Verdana" size=2>
<hr noshade width="50%">
Total Messages = $tm
<hr noshade width="50%">
</font></td></tr>
<tr><td bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <a href="$base_url?options=register">Registration Information</a><br>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</table>
</body></html>
~;
} # end display messages all function

#--------------------------------------------#
# Print all children messages function       #
# This is a recursive function               #
#--------------------------------------------#
sub print_all_children
  {
local (@children_list) = @_;
print ("<ul>"); # start a nested list item
foreach $this_child (@children_list) {
	@this_child_fields = split(/\|/, $ordered_messages[$this_child]);
	$message_number = "message_number\=$this_child_fields[0]"; # Sets the variable for use in the href link
	print qq~
	<li>
	<img src="$icon_path$this_child_fields[7]">
	~;
	print ("<a href=\"$base_url\?file\=$form_data{'ffile'}\&mode\=update\&message_number\=$this_child_fields[0]\">$this_child_fields[4]</a>");
	print (" - <b>$this_child_fields[2]</b> $this_child_fields[1] \($this_child_fields[13]\)\n");
	if ($this_child_fields[12] ne "") { # this child has children
	  @list_to_send = split(/,/, $this_child_fields[12]);
	  &print_all_children(@list_to_send);
	  } # end if
} # end foreach

print ("</ul>"); # End the nested list items

} # end function

#-----------------------------------------------------------------------#
# Display message details and allows user to edit or delete the message #
#-----------------------------------------------------------------------#
sub show_message
  {
print qq~
<html><head><title>Administration Modify a Forum</title>
</head>
<body background="$background_image">
<font face="Verdana" size=2>
<center>
<br><br>
<FORM METHOD="post" ACTION="$base_url">
<INPUT TYPE="hidden" NAME="mode" VALUE="update_record">
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=5 cellspacing=0 width=600 border=0 bgcolor="#000000">
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Administration Modify</u></h2></font></td></tr>
~;
@record_data = &load_datafile($form_data{'file'});
# Create a new array with the subsets corrisponding to the record number
foreach (@record_data) {
	@rd_fields = split(/\|/, $_);
	$ordered_records[$rd_fields[0]] = $_;
}
@message_data = split(/\|/, $ordered_records[$form_data{'message_number'}]);
$delete_button = "Delete This Message";
if ($message_data[13] != 0) {
	$delete_button = "Delete Entire Thread";
print qq~
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <font color="red">WARNING<font color="black"><br>This message has replies.
     Deleting this message will remove all the replies also.</font></td></tr>
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><hr noshade width="50%"></td></tr>
~;
}
print qq~
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    To modify this message, edit any field and click MODIFY<br>
    To delete this message, click on DELETE<br>&nbsp;</font></td></tr>
<tr><td align="center" bgcolor="#E6E6FA" width=100><font face="Verdana" size=2 color="blue">
    Field</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2 color="blue">
    Current value</font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Date</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="date" VALUE="$message_data[1]" SIZE="20"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Name</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="name" VALUE="$message_data[2]" SIZE="20"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    E-Mail</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="email" VALUE="$message_data[3]" SIZE="20"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Subject</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="subject" VALUE="$message_data[4]" SIZE="40"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Body</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <TEXTAREA COLS="40" ROWS="10" NAME="body" WRAP="yes">$message_data[5]</TEXTAREA></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Notify Me</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="notify_me" VALUE="$message_data[6]" SIZE="2"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Post Type</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="post_type" VALUE="$message_data[7]" SIZE="20"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Link URL</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="link_url" VALUE="$message_data[8]" SIZE="40"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Link Title</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="link_title" VALUE="$message_data[9]" SIZE="40"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    Image URL</font></td>
    <td align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="text" NAME="image_url" VALUE="$message_data[10]" SIZE="40"></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td colspan=2 align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <INPUT TYPE="hidden" NAME="uid" VALUE="$message_data[0]">
    <INPUT TYPE="hidden" NAME="parent" VALUE="$message_data[11]">
    <INPUT TYPE="hidden" NAME="children" VALUE="$message_data[12]">
    <INPUT TYPE="hidden" NAME="replies" VALUE="$message_data[13]">
    <INPUT TYPE="hidden" NAME="forum_setup" VALUE="$message_data[14]">
    <INPUT TYPE="hidden" NAME="file_to_use" VALUE="$form_data{'file'}">
    <INPUT TYPE="submit" VALUE=" Update Message "></form></font></td></tr>
<tr><td colspan=2 bgcolor="#E6E6FA" align="center"><hr noshade width="90%"></td></tr>
<tr><td colspan=2 align="center" bgcolor="#E6E6FA"><font face="Verdana" size=2>
    <FORM METHOD="post" ACTION="$base_url">
    <INPUT TYPE="hidden" NAME="mode" VALUE="delete_record">
    <INPUT TYPE="hidden" NAME="uid" VALUE="$message_data[0]">
    <INPUT TYPE="hidden" NAME="children" VALUE="$message_data[12]">
    <INPUT TYPE="hidden" NAME="file_to_use" VALUE="$form_data{'file'}">
    <INPUT TYPE="submit" VALUE=" $delete_button "></form></font></td></tr>
<tr><td colspan=2 bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <a href="$base_url?options=register">Registration Information</a><br>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;
} # end function

#-------------------------------------------#
# Updates a record with the new information #
#-------------------------------------------#
sub update_record
   {

open (FDF, "+< $form_data{'file_to_use'}" );
flock(FDF, 2);
  @record = <FDF>;
# Create a new array with the subsets corrisponding to the record number
# Also need to pull out the comment lines
foreach (@record) {
	if ($_ =~ /^COMMENT:/) {
		push(@comment_records, $_);
	} else {
		@line = split(/\|/, $_);
		$ordered_records[$line[0]] = $_;
	}
}
$new_record .= "$form_data{'uid'}\|";
$new_record .= "$form_data{'date'}\|";
$new_record .= "$form_data{'name'}\|";
$new_record .= "$form_data{'email'}\|";
$new_record .= "$form_data{'subject'}\|";

$form_data{'body'} =~ s/\n/<BR>/g;
$form_data{'body'} =~ s/\r/ /g;
$form_data{'body'} =~ s/\r\r/<P>/g;
$form_data{'body'} =~ s/\|/:/g;

$new_record .= "$form_data{'body'}\|";
$new_record .= "$form_data{'notify_me'}\|";
$new_record .= "$form_data{'post_type'}\|";
$new_record .= "$form_data{'link_url'}\|";
$new_record .= "$form_data{'link_title'}\|";
$new_record .= "$form_data{'image_url'}\|";
$new_record .= "$form_data{'parent'}\|";
$new_record .= "$form_data{'children'}\|";
$new_record .= "$form_data{'replies'}\|";
$new_record .= "$form_data{'forum_setup'}";

$ordered_records[$form_data{'uid'}] = $new_record;

seek(FDF, 0,0);
foreach (@comment_records) {
	print FDF "$_";
}
foreach (@ordered_records) {
	print FDF "$_";
}
truncate(FDF, tell(FDF));
flock(FDF, 8);
close(FDF);
# Notify the user the update is complete.
print qq~
<html>
<head>
<title>Operation Complete</title>
</head>
<body background="$background_image">
<center>
<br><br><br><br>
<table border=1 bgcolor="#000000" cellpadding=2>
<tr><td>
<table cellpadding=0 cellspacing=0 width=480 border=0 bgcolor="#000000">
<tr><td bgcolor="#FFFFE0" align="center"><font face="Verdana">
	<h2><u>Operation Complete</u></h2></font></td></tr>
<tr><td bgcolor="#FFFFE0" align="center"><hr noshade width="50%"></td></tr>
<tr><td bgcolor="#FFFFE0" align="center"><font face="Verdana" size=2>
    <br>[<a href="$base_url"> Return to Control Panel </a>]<br>&nbsp;</font></td></tr>
</td></tr></table></td></tr></table>
</center></body></html>
~;
} # end function

#------------------------------------------------------------#
# Delete message function.                                   #
# This will delete a specific message or it's entire thread. #
# The entire thread is defined as all messages below the     #
# desired message. In otherwords, this prunes down the tree  #
# not up the tree.
#------------------------------------------------------------#
sub delete_record
  {
open (FDF, "+< $form_data{'file_to_use'}" );
flock(FDF, 2);
  @record = <FDF>;
# Create a new array with the subsets corrisponding to the record number
# Also need to pull out the comment lines
foreach (@record) {
	if ($_ =~ /^COMMENT:/) {
		push(@comment_records, $_);
	} else {
		@line = split(/\|/, $_);
		$ordered_records[$line[0]] = $_;
	}
}
# Now get the desired record and split it into fields for further examination.
@rtd_fields = split(/\|/, $ordered_records[$form_data{'uid'}]);

# Start the list of records to delete with this one
push(@delete_list, $form_data{'uid'});

# Now run the gambit and find all of it's associated children
&get_children($form_data{'uid'});
# Now check the origonal message to see if it has a parent
$pat = $form_data{'uid'};

if ($rtd_fields[11] ne "") {# zhuhan: replaced the original if ($rtd_fields[11])
	# Update it's parent record
	@parent_fields = split(/\|/, $ordered_records[$rtd_fields[11]]);
	$parent_fields[12] =~ s/$pat\,//;
	$parent_fields[13] -= 1;
	$ordered_records[$rtd_fields[11]] = join("|", @parent_fields);
}

# Now we need to delete all the records contained in the delete list.
foreach $rtd (@delete_list) {
	undef ($ordered_records[$rtd]);
}
# Now re write the file and close
seek(FDF, 0,0);
foreach (@comment_records) {
	print FDF "$_";
}
foreach (@ordered_records) {
	print FDF "$_";
}
truncate(FDF, tell(FDF));
flock(FDF, 8);
close(FDF);
# Now return the user to the forum message display thaey were looking at.
chomp($rtd_fields[14]);
$form_data{'ffile'} = "$rtd_fields[14].data";
$form_data{'sfile'} = "$rtd_fields[14].setup.cgi";
$form_data{'sfile'} = "_forum.rc";
&message_display_all;
} # end of function

#-----------------------------------------------#
# Get children                                  #
# This is used by the delete record function    #
# to handle message threads. This will populate #
# a list with the desired records to delete.    #
#-----------------------------------------------#
sub get_children
   {
local ($tc);
local (@temp_children);
@received = @_;
@fields2 = split(/\|/, $ordered_records[$received[0]]);
if ($fields2[12]) {
	@temp_children = split(/,/, $fields2[12]);
	foreach $tc (@temp_children) {
		push(@delete_list, $tc);
		&get_children($tc);
	}

}
} # end get children function

#---------------------------------------------------------------#
# Error Control Function                                        #
# Provides a standard error reporting utility to display errors #
# to the browser.                                               #
#---------------------------------------------------------------#
sub error_control
  {
local ($error_msg) = @_;
print qq~
<html>
<head>
<title>DB TalkToMe ERROR Control</title>
</head>
<body bgcolor="#6699FF">
<center>
<table border=1 cellpadding=5 cellspacing=5 bgcolor="white" width="400">
<tr><td align="center"><font face="Verdana" size=2>
    <b>Error Control</b></font></td></tr>
<tr><td align="left"><font face="Verdana" size=2>
    There was an error condition in the program.<br>Please use your browsers back
    button and correct the problem.</font></td></tr>
<tr><td align="center"><font face="Verdana" size=2>
    <b>Here's what I know about the problem.</b><br>
    $error_msg<br><br></font></td></tr>
<tr><td align="center"><font face="Verdana" size=2>
    If you continue to have trouble<br>
    <a href="mailto:$error_admin">E-mail the administrator</a></font></td></tr>
</table>
</body>
</html>
~;
exit;
} # end error control function


### tools for debuggin
sub displayText {
my @messages=@_;
print "content-type:text/html\n\n";
print "<pre>\n";
while(<@messages>) {
    print "[$_]";
}
exit 0;
}


sub forcedExit {
    print "content-type:text/html\n\n";
    print "forced exit!";
    exit 0;
}
