#!/usr/bin/perl

#---------------------------------------------
# (c) Zhuhan Jiang
#     version 1.13  12 July 2007
# Freeware under GNU copyright convention.
#---------------------------------------------

###### user configuration ######
# this line must be copied from inside _conf-b.rc
$sessionSecurityMask="cmFuZG9tcGhyYXNl"; # randomphrase
################################


use CGI qw(:standard);
use CGI::Carp qw/fatalsToBrowser/;

# sub CGI::url { return $ENV{'SCRIPT_URI'}; }

$cgi=new CGI;

if(!loggedIn($cgi)) {
  do "_verify-b.pl";
  if(!verifyPassword($cgi)) { submitPage(); }
  exit 0;
}

sub loggedIn {
my($cgi)=@_;
my($sessionid,$loginid,$unitshortname);
  $loginid=$cgi->cookie(-name=>'loginid');
  $sessionid=$cgi->cookie(-name=>'sessionid');
  $unitshortname=$cgi->cookie(-name=>'unitshortname');
  if(!sessionChecked($sessionid,$loginid,$unitShortName)) { return 0; }
  if("$loginid" ne "") {
    param(-name=>'loginid',-default=>"$loginid");
    param(-name=>'unitshortname',-default=>"$unitshortname");
    return 1;
  }
  return 0;
}


#
# 1. generate 4 random numbers between 0 and 51: r0, r1, r2, r3
# 2. time in seconds converted to base 52 number in 8 digits: t0, t1, .., t7
# 3. ordinal values of first 4 letters of login name applied by modulus 4: n0, n1, n2, n3
# 4. form array  ALL= (r0,r1,r2,r3, t0,t1,t2,t3, t4,t5,t6,t7, n0,n1,n2,n3)
# 5. add positionwise the MASK=(r0,r1,r2,r3, r0,r1,r2,r3, r0,r1,r2,r3, r0,r1,r2,r3)
#     i.e. ALL = ALL + MASK
# 6. keep all values of array ALL between 0 and 51 via % 52
# 7. represented each element of ALL via a letter A-Z or a-z
# 8. concatenate 16 characters into a single session text string
#

# character-wise xor the text with the mask
sub xorText {
my($text,$mask)=@_;
my($m,$n,$p);
  $m=length($text);
  $n=length($mask);
  if(!$m || !$n) {
    return $text;
  }
  if($m>$n) {
    $p=int($m/$n);
    $mask= $mask x ($p+1);
  }
  $mask=substr($mask,0,$m);
  return $text ^ $mask;
}

sub getTimeNum {
my($time)=time();
my(@num)=(0,0,0,0,0,0,0,0);
my($i);
  for $i (7,6,5,4,3,2,1,0) {
    $r=$time % 52;
    $time = int($time/52);
    $num[$i]=$r;
  }
  return @num;
}

sub text2Num {
my($text)=@_;
$text=xorText($text,$sessionSecurityMask);
my($n)=length($text);
my($i,$c,@num);
  for($i=0;$i<$n;$i++) {
    $c=ord(substr($text,$i,1));
    $c %= 52;
    $num[$i]=$c;
  }
  return @num;
}

sub randomNum {
my($total)=@_;
my(@num)=();
my($i);
  for($i=0; $i<$total; $i++) {
    $num[$i]=int(rand(52));
  }
  return @num;
}

sub makeCryptedTime {
my(@time)=getTimeNum();
my(@name)=text2Num(@_);
my(@key)=randomNum(4);
my(@all);
my($text)="";
my($i,$m,$n);
  for($i=0;$i<4;$i++) {
    if($i>$#name) {
      $name[$i]=0;
    }
  }
  @all=(@key, @time, @name);
  for($i=4;$i<16;$i++) {
     $n=$all[$i%4];
     $m=$all[$i];
     $all[$i]=($m+$n) % 52;
   }
  for($i=0; $i<16; $i++) {
    $n=$all[$i];
    if($n<26) {
      $c=chr(ord('A')+$n);
    } else {
      $c=chr(ord('a')+$n-26);
    }
    $text.= $c;
  }
  return $text;
}

sub checkCryptedTime {
my($cryptedTime,$loginText)=@_;
my(@time)=getTimeNum();
my(@name)=text2Num($loginText);
my(@all)=();
my($i,$m,$n,$total,$matched);
  for($i=0;$i<4;$i++) {
    if($i>$#name) {
      $name[$i]=0;
    }
  }
  for($i=0; $i<16; $i++) {
    $c=substr($cryptedTime,$i,1);
    $n=ord($c);
    if($n<=ord('Z')) {
      $m=$n-ord('A');
    } else {
      $m=$n-ord('a')+26;
    }
    $m %=52;
    $all[$i]=$m;
  }
  for($i=4;$i<16;$i++) {
     $n=$all[$i%4];
     $m=$all[$i];
     $all[$i]=($m-$n) % 52;
   }
  $total=0;
  $n=1;
  for($i=11;$i>=4;$i--) {
    $total+= $all[$i]*$n;
    $n*=52;
  }
  $matched=1;
  for($i=12;$i<16;$i++) {
    $matched= $matched && !($all[$i] - $name[$i-12]);
   }
   if(!$matched) { $matched=0; }
  return ($total,$matched);
}

sub sessionChecked {
my($sessionid,$loginid,$unitShortName,$sessionlimit)=@_;
my($time)=time();
my($oldTime,$matched)=checkCryptedTime($sessionid,
                        $loginid . ' ' . $unitShortName);
  if(!$matched) {
    return 0;
  }
  if($time>=$oldTime) {
    $time -= $oldTime;
  } else {
    $time = $oldTime - $time;
  }
  if(!defined($sessionlimit)) {
    $sessionlimit=36000;     # 10 hours
  }
  if($time<= $sessionlimit) {
     return 1;
  } else {
     return 0;
  }
}

# print "content-type: text/html\n\n OK";
