#!/usr/bin/perl

#---------------------------------------------
# (c) Zhuhan Jiang
#     version 1.17  10 February 2010
# Freeware under GNU copyright convention.
#---------------------------------------------

# external configuration file
$externConfig="_conf-b.rc";
do "${baseDir}$externConfig";

# fetch unit/purpose/duedates info
@cfgarray=split(/\n/,$cfgtext);


sub trim {
my($s)=@_;
  if($s=~/^\s*(.*\S)\s*$/) { return "$1"; }
  return "$s";
}


$defaultUnitCount=0;
$defaultUnitName="";

sub parseCfgX { # global: $defaultUnitCount, $defaultUnitName
my(@cfg)=@_;
my($data)=[];
my($count,$subcount)=(0,0);
my($title,$alias,$quizwhere,$imagewhere)=("","","","");
my($aline,$name,$due,$late);
my($entry)=[];
my($titlecount)=-1;
  foreach $aline(@cfg) {
    $name=$dir=$due=$late="";
    if($aline=~/^([^#]*)#.*$/) {
      $aline="$1";
    }
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^(.*)$/) { $aline="$1"; }
    $aline=~tr/a-zA-Z0-9[](){}<>+\-*\/,.:!?@#$%^&= ~/_/cs;
    if($aline=~/^([^,]*),(.*)$/) {
      $name="$1"; $aline="$2";
      if($aline=~/^([^,]*),(.*)$/) {
        $dir="$1";  $aline="$2";
        if($aline=~/^([^,]*),(.*)$/) {
          $due="$1";  $aline="$2";
          if($aline=~/^([^,]*),(.*)$/) {
            $late="$1";  $aline="$2";
          } else { $late=$aline; }
        } else { $due=$aline; }
      } else { $dir=$aline; }
    } else { $name=$aline; }
    $name=trim($name);
    $dir=trim($dir);
    $due=trim($due);
    $late=trim($late);
    if($name=~/^\*+\s*(.*)$/) {
      $aline="$1";
      $titlecount++;
      if($name=~/^\*\*/) {
        $defaultUnitCount=$titlecount;
        $defaultUnitName=$aline;
      }
      # $name="$1";
      $name=$aline;
      if($title ne "") {
        $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere];
      }
      $title=$name; $alias=$dir;
      $quizwhere=$due; $imagewhere=$late;
      $subcount=0;
      $entry=[];
    }
    else {
      $entry->[$subcount++]=[$name,$dir,$due,$late];
    }
  }
  if($#cfg>=0) { $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere]; }
  return $data;
}


sub cvtCfgX{ # global: $defaultUnitCount
my($data,$unit)=@_;
my($i,$j,$name,$entry);
my(%unitmap)=();
my(%purposemap)=();
my(%duedate)=();
my(%latedate)=();
my(%quizdirmap)=();
my(%imagebasemap)=();
  $i=0;
  if(!defined($unit)) { $unit=""; }
  while(1) {
    $entry=$data->[$i];
    if(!defined($entry)) { last; }
    $name=$entry->[0];
    $unitmap{"$name"}=$entry->[1];
    $quizdirmap{"$name"}=$entry->[3];
    $imagebasemap{"$name"}=$entry->[4];
    if("$name" eq "$unit" || $i==$defaultUnitCount && "$unit" eq "") {
      $entry=$entry->[2];
      $j=0;
      while(1) {
        if(!defined($entry->[$j])) { last; }
        $name=$entry->[$j][0];
        $purposemap{"$name"}=$entry->[$j][1];
        $duedate{"$name"}=$entry->[$j][2];
        $latedate{"$name"}=$entry->[$j][3];
        $j++;
      }
    }
    $i++;
  }
  return (\%unitmap,\%quizdirmap,\%imagebasemap,\%purposemap,\%duedate,\%latedate);
}


# get %unitmap etc
@cfgXParsed=parseCfgX(@cfgarray);
if(param('unitname') eq "") {
  param(-name=>'unitname',-default=>$defaultUnitName);
}
(*unitmap,*quizdirmap,*imagebasemap)=cvtCfgX(@cfgXParsed,param('unitname'));

