#!/usr/bin/perl
# version 1.0 Zhuhan Jiang 2011 (renamed ver 2.01)

# user configuration is in "_browse.rc"
# allow only users of tutor status to access
do "./_login-b.pl";
do "./_istutor-b.pl";

# load main configuration if not already loaded
if(!$CONFIG_LOADED) {
    do "./_conf-b.rc";
}

# function lineInFile is defined in _istutor-b.pl or _ischieftutor-b.pl
$loginid=$cgi->cookie(-name=>'loginid');
$isChiefTutor=lineInFile($loginid, $fileForChiefTutors);

# locate unit short name
$unitShortName=$cgi->cookie(-name=>'unitshortname');

# download logfile: $logfiledir only created by browse.pl
$logfile="${logfiledir}/downloads.log";

# $masterroot - all browsing starts here
$masterroot="/rusers/staff/zhuhan/Homepage/courses";
$masterroot="${webhomedir}/courses";

# which directories are allowed to access
$masterpermission="/rusers/staff/zhuhan/Homepage/courses:/rusers/staff/zhuhan/Homepage/pub";
$masterpermission="${masterroot}:${webhomedir}/pub";

# which directories are NOT allowed access
# priority over masterpermission
# $browsedisapproval="$/rusers/staff/zhuhan/Homepage/courses/feedback";

# additional directory permission to set (not used yet)
$localpermission="";

# unit-wise root/permission
$unitroot=$masterroot;
$unitpermission=$masterpermission;

# read main configurations
do "./_browse.rc";

# read overriding user configurations for specific units, if available
# but chief tutors will not be subject to this limitation
if(!$isChiefTutor) {
    do "./config/${unitShortName}_browse.rc";
}

# absorb '//' and remove trailing '/' from $masterroot
1 while $masterroot=~ s/\/\//\//g;
1 while $masterroot=~ s/\/$//g;
1 while $unitroot=~ s/\/\//\//g;
1 while $unitroot=~ s/\/$//g;

# create logfile directory if not already in existence
if(! -d "$masterroot") { mkdir "$masterroot",0700; }
if(! -d "$unitroot") { mkdir "$unitroot",0700; }
if(! -d "$logfiledir") { mkdir "$logfiledir",0700; }


# support tools for the browsing;
# need to apply escape() to all parameters
my $savefile_pl="savefile.pl";
my $savedir_pl="savedir.pl";
my $viewfile_pl="viewfile.pl";
my $logout_pl="logout-b.pl";


# other variables of interest
my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
   $atime,$mtime,$ctime,$blksize,$blocks);
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday);
my($entry,$printed,$count);


# URL of this submission program
# $submitURL=url();

# used perl modules
use CGI qw(:standard);

$currentdir=$dir=param('dir');
$relativepath=param('path');
$listmode=param('listmode');
$title=param('title');

# extend permission to chief tutors
if($isChiefTutor) {
    $unitroot=$masterroot;
    $unitpermission=$masterpermission;
}

# decompose path info
$root=$unitroot;
if($relativepath=~ /^\s*$/) { $relativepath=""; }
$dir=absolutePath($root,$relativepath,$dir);
$pathtail=pathTail($root,$dir);
if($listmode ne "") { $listmode="-t"; } # defeat hacker

# check for illegal characters
($validity,$combined)=validCharacters($dir,$relativepath,$listmode,$title);
if(!$validity) {
  print "Content-type: text/plain\n\n";
  print "Illegal characters in parameters [$combined].\n";
  exit 0;
}

# check for directory permission
if(
   # always force the master permission check
   !permitted($masterpermission,$localpermission,$dir)
   # then check against unit permission
   || !permitted($unitpermission,$localpermission,$dir)
  ) {
  if(${dir}=~ /^${root}(.*)$/) { $dir="~$1"; }
  print "Content-type: text/html\n\n";
  print "Permission to [$dir] denied.\n";
  exit 0;
}




print <<EOF_PART_ONE
Content-type: text/html

<html><head><title>File Folders</title></head>

<style type="text/css">
a:link {  text-decoration: none; color:0000ff;}
a:active { text-decoration: none; color:3399ff;}
a:visited { text-decoration: none; color:60a0a0;}
//a:hover { text-decoration: none; color:ffd700; color:ff0000;}
a:hover{ background-color:#80e0e0; color:black; }

.packed {
  table-layout:fixed;
  border-top: 0px solid #888888;
  border-collapse: collapse;
}

.packed td {
//  border-bottom: 1px dashed #dddddd;
  padding: 0px 0px;
  overflow:hidden;
  text-overflow:ellipsis;
  white-space:nowrap;
}

</style>

<UL>
EOF_PART_ONE
    ;



# print title
if($title eq "") {
print <<EOF_PART_TWO

<table><tr><td bgcolor=#0066aa>
<table cellspacing=10 cellpadding=10 bgcolor=#0066aa>
<tr><td align=center>
<font face="Arial, Helvetica, sans-serif" color=white size=+3>
<B>BROWSE and DOWNLOAD ($unitShortName)</B>
</font></td></tr></table>
</td></tr></table><p>

<ul type=square>
<li>click <img src=$cgiscriptimages/tri_gn.gif> to download a file.
<li>click <img src=$cgiscriptimages/tri_rd.gif> to download a directory plus subdirectories in "tar.z" format.
<li>click a file name to view the content in <i>raw</i> format.
</ul>

EOF_PART_TWO
;

} else {
 print "<H1><B><font face='Arial, Helvetica, sans-serif'>$title</font></B></H1>\n";
}

print "<hr align=left width=75%>\n";


# normal files
if(open(DIR,"ls $listmode '$dir'|")) {
  $printed=0;
  while(<DIR>) {
      $entry="$_";
      if($entry=~/^\s*(\S.*)\s*$/) { $entry="$1"; } # strip '\n'
      if(($entry =~/^\s*$/) || $entry eq "." || $entry eq ".."
         || !($entry=~/^[a-zA-Z0-9_ \.\-\:]*$/) ) {
	  next;
      }

      ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
       $atime,$mtime,$ctime,$blksize,$blocks)= stat("$dir/$entry");
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($mtime);

      if(-e _ && !-d _ && -r _ && -s _ ) {
      if($printed) { print "<br>"; } else { $printed=1; }
      print
         "<a href=" . makeUrl($savefile_pl)
       . "?file=" . escape($entry) . "&path=" . escape($pathtail)
       . " title='download file'>"
       . "<img src=$cgiscriptimages/tri_gn.gif border=0>"
#       . "<font color=black face=wingdings>&#60;</font>"
       . "</a> <a href=" . makeUrl($viewfile_pl)
       . "?file=" . escape($entry) . "&path=" . escape($pathtail)
       . " title='view content'>$entry</a> "
       . "<font size=-1 color=silver>$size //$mday "
       . month($mon). " " . ($year+1900) . " $hour:$min:$sec</font> \n";
      }
  }
  close(DIR);
}


# directories
if(open(DIR,"ls $listmode '$dir'|")) {
  $printed=0;
  $count=0;
  while(<DIR>) {
      $entry="$_";
      if($entry=~/^\s*(\S.*)\s*$/) { $entry="$1"; } # strip '\n'
      if(($entry =~/^\s*$/) || $entry eq "." || $entry eq ".."
         || !($entry=~/^[a-zA-Z0-9_ \.\-\:]*$/) ) {
	  next;
      }

      ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
       $atime,$mtime,$ctime,$blksize,$blocks)= stat("$dir/$entry");
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($mtime);

      if(-e _ && -d _ && -r _ ) {

        # start of table
        if(!$printed) {
          $printed=1;
          print "<table cellpadding=0 cellspacing=0 width=\"90\%\" class=packed>";
        };

        if(!$count) { print "<tr>\n" ; }

        print "<td><a href=" . makeUrl($savedir_pl)
         . "?file=" . escape($entry) . "&path=" . escape($pathtail)
         . " title='download dir'>"
         . "<img src=$cgiscriptimages/tri_rd.gif border=0>"
#         . "<font color=black face=wingdings>&#61;</font>"
         . "</a> <a href=" . url()
         . "?path=" . escape($pathtail) . "&dir=". escape($entry)
         . "&title=DIR:+\~" . escape(absorbSlash("/$pathtail/$entry"))
         . "&listmode=$listmode>[dir] $entry</a> <font size=-1 color=silver> $mday "
         . month($mon). " " . ($year+1900) . " $hour:$min</font></td>\n";

        if($count) { print "\n</tr>\n"; $count=0; } else { $count=1; }
      }
  }

  # closing the table
  if ($printed && !$count) { print "</tr>\n"; }
  print "</table>\n";
  close(DIR);
}


print "<p>";

# hidden files
if(open(DIR,"ls $listmode '$dir'|")) {
  $printed=0;
  $count=0;
  while(<DIR>) {
      $entry="$_";
      if($entry=~/^\s*(\S.*)\s*$/) { $entry="$1"; } # strip '\n'
      if(($entry =~/^\s*$/) || $entry eq "." || $entry eq "..") {
	  next;
      }

      ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
       $atime,$mtime,$ctime,$blksize,$blocks)= stat("$dir/$entry");
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($mtime);

      if(-e _ && !-d _ && !-r _ ) {

        if(!$printed) {# start of table
          $printed=1;
          print "<table bgcolor=\"\#dddddd\" cellpadding=0 cellspacing=0 width=\"90\%\" class=packed>";
        };

        if(!$count) { print "<tr>\n" ; }
        print "<td>$entry <font size=-1 color=silver>$size //$mday "
              . month($mon). " " . ($year+1900) . " $hour:$min</font></td>\n";
        if($count) { print "\n</tr>\n"; $count=0; } else { $count=1; }
      }
  }

  # closing the table
  if ($printed && !$count) { print "</tr>\n"; }
  print "</table>\n";
  close(DIR);
}


# hidden directories
if(open(DIR,"ls $listmode '$dir'|")) {
  $printed=0;
  $count=0;
  while(<DIR>) {
      $entry="$_";
      if($entry=~/^\s*(\S.*)\s*$/) { $entry="$1"; } # strip '\n'
      if(($entry=~/^\s*$/) || $entry eq "." || $entry eq "..") {
	  next;
      }

      ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
       $atime,$mtime,$ctime,$blksize,$blocks)= stat("$dir/$entry");
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($mtime);

      if(-e _ && -d _ && !-r _ ) {

        if(!$printed) {# start of table
          $printed=1;
          print "<table bgcolor=\"\#dddddd\" cellpadding=0 cellspacing=0 width=\"90\%\" class=packed>";
        };

        if(!$count) { print "<tr>\n" ; }
        print "<td>[dir] $entry <font size=-1 color=silver> $mday "
              . month($mon). " " . ($year+1900) . " $hour:$min</font></td>\n";
        if($count) { print "\n</tr>\n"; $count=0; } else { $count=1; }
      }
  }

  # closing the table
  if ($printed && !$count) { print "</tr>\n"; }
  print "</table>\n";
  close(DIR);
}




# html tail
print "<P><hr align=left width=75%><P>\n";
print "<form>";

$previousdir=pathTail($root,$dir);
($previousdir,$prevDir)=pathAheadRelative($previousdir);
($prevPath,$prevDir)=pathAheadRelative($previousdir);
$absoluteprevdir=absolutePath($root,$relativepath,$previousdir);

if( $dir ne $absoluteprevdir &&
    permitted($unitpermission,$localpermission,$absoluteprevdir) ) {
  print "<input type=button onclick=\"location='" . url() . "?dir=" . $prevDir
   . "&path=$prevPath&title=DIR:+\~"
   . absorbSlash("/$previousdir")
   . "&listmode=$listmode';\" value='up'> &nbsp; ";

}

print "<input type=button onclick=\"location='". makeUrl($logout_pl)
   . "';\" value=\"logout browse\">";


if($listmode eq "-t") { $listmode=""; } else { $listmode="-t";}

if($listmode eq "-t") {

  print " <input type=button onclick=\"location='" . url() . "?"
   . "dir=$currentdir&path=$relativepath&listmode=$listmode"
#   . "&title=DIR:+\~" . absorbSlash("/$relativepath/$currentdir")
   . "&title=$title"
   . "';\" value='by date'>";

} else {

  print " <input type=button onclick=\"location='" . url() . "?"
   . "dir=$currentdir&path=$relativepath&listmode=$listmode"
#   . "&title=DIR:+\~" . absorbSlash("/$relativepath/$currentdir")
   . "&title=$title"
   . "';\" value='by name'>";

}

print "</form>";

if ( $title eq "" ) {
  print "<font size=-2 style='position:relative; top:-5px; left:1px;'>&copy; 2012 Zhuhan JIANG</font>\n";
}





#################
# subroutines
#################

sub writeLog {
my($uid,$sid,$ip,$message)=@_;
my($time)=time;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($time);
  $year=$year % 100;
  if($year<10) { $year="0$year"; }
  if(open(LOGFILE,">>$logfile")) {
    flock(LOGFILE, 2);
    print LOGFILE "$uid $sid, $ip, $mday/",$mon+1,"/$year $hour:$min:$sec, $message\n";
    flock(LOGFILE, 8);
    close(LOGFILE);
    chmod 0600, "$logfile";
  }
}


# check for the permitted characters in form parameters
sub validCharacters {
my (@allParas)=@_;
my($onePara);
my($combined);
$combined=join(' ',@allParas);
for $onePara (@allParas) {
  if($onePara !~ /^[a-zA-Z0-9_\@\/\~\-\.\x2f\s:\x5c]*$/) {
    return (0,$combined);
  }
}
return (1,$combined);
}


# check for directory permission
# absorb '//' within $browsedisapproval for the permission checking
sub permitted {
my($masterpermission,$localpermission,$dir)=@_;
# 1 while $browsedisapproval=~ s/\/\//\//g;
  return ($dir ne "") && ($dir !~ /\.\./)

      # safty check to bar dirty trick users
      && ($dir =~ /^[a-zA-Z0-9_@\-\.\x2f\s:\x5c]*$/)
      # && ($dir =~ /^[a-zA-Z0-9_ \.\-\:\/]*$/)

      && withinPath($masterpermission,$dir)
      && !withinPath($browsedisapproval,$dir)
      && ($localpermission eq "" || withinPath(localpermission,$dir)) ;
}


# check if dir is leading part of one of permissionpath separated by ":"
sub withinPath {
my($permissionpath,$dir)=@_;
my(@allpaths,$path);
  if("$dir" eq "") {
    return 0;
  }
  @allpaths=split(/:/, $permissionpath);
  foreach $path (@allpaths) {
    if($dir =~ m#^$path.*# ) {
      return 1;
    }
  }
  return 0;
}


# remove leading/trailing spaces, absorb "//", remove trailing "/"
sub absolutePath {
my($root,$relativepath,$dir)=@_;
my($absolute);
  if($dir=~/^\//) {
    $absolute=$dir;
  } else {
    $absolute="$root/$relativepath/$dir";
  }
  1 while $absolute=~ s/\/\//\//g;
  if($absolute=~/^(\/.*)\/$/) {
    $absolute="$1";
  }
  return $absolute;
}


sub absorbSlash { # remove duplicated "/", insert " " after "/"
my($path)=@_;
  1 while $path=~ s/\/\//\//g;
  $path=~ s/\//\/ /g;
  return $path;
}


sub escape {
my($text)=@_;
  $text=~ s/([^a-zA-Z0-9])/sprintf('%%%x',ord($1))/eg;
  return $text;
}


sub month {
my($month)=@_;
my($text)="";
  if($month==0) {
    $text="Jan";
  } elsif($month==1) {
    $text="Feb";
  } elsif($month==2) {
    $text="Mar";
  } elsif($month==3) {
    $text="Apr";
  } elsif($month==4) {
    $text="May";
  } elsif($month==5) {
    $text="Jun";
  } elsif($month==6) {
    $text="Jul";
  } elsif($month==7) {
    $text="Aug";
  } elsif($month==8) {
    $text="Sep";
  } elsif($month==9) {
    $text="Oct";
  } elsif($month==10) {
    $text="Nov";
  } elsif($month==11) {
    $text="Dec";
  };
  return $text;
}


sub makeUrl {
my($scriptname)=@_;
my($url,$relative);
  $url=url();
  $relative=url(-relative=>1);
  if($url=~/^(.*)$relative$/){
    return "$1$scriptname";
  }
  return $scriptname;
}


sub pathTail {
my($root,$absolute)=@_;
my($rest)="";
  if($absolute=~/^$root(.*)$/) {
    $rest="$1";
  }
  if($rest=~/^\/(.*)$/) {
    $rest="$1";
  }
  if($rest=~/^(.*)\/$/) {
    $rest="$1";
  }
  return $rest;
}


sub pathAheadRelative {
my($tail)=@_;
my($head)="";
  if($tail=~/^(.*)\/([^\/]*)$/) {
    $head="$1";
    $tail="$2";
  }
  return ($head,$tail);
}

