#!/usr/bin/perl
# version 1.0 Zhuhan Jiang 2011
# format:  editfeedback.pl?file="your filename"

# user configuration is in "_browse.rc"
# allow only users of tutor status to access
do "./_login-b.pl";
do "./_istutor-b.pl";

# load main configuration if not already loaded
if(!$CONFIG_LOADED) {
    do "./_conf-b.rc";
}

# function lineInFile is defined in _istutor-b.pl or _ischieftutor-b.pl
$loginid=$cgi->cookie(-name=>'loginid');
$isChiefTutor=lineInFile($loginid, $fileForChiefTutors);

# locate unit short name
$unitShortName=$cgi->cookie(-name=>'unitshortname');

# download logfile: $logfiledir only created by browse.pl
$logfile="${logfiledir}/downloads.log";

# $masterroot - all browsing starts here
# $masterroot="/rusers/staff/zhuhan/Homepage/courses";
$masterroot="${webhomedir}/courses";

# which directories are allowed to access
# $masterpermission="/rusers/staff/zhuhan/Homepage/courses:/rusers/staff/zhuhan/Homepage/pub";
$masterpermission="${masterroot}:${webhomedir}/pub";

# which directories are NOT allowed access
# priority over masterpermission
# $browsedisapproval="$/rusers/staff/zhuhan/Homepage/courses/feedback";

# additional directory permission to set (not used yet)
$localpermission="";

# unit-wise root/permission
$unitroot=$masterroot;
$unitpermission=$masterpermission;

# read main configurations
do "./_feedback.rc";

# absorb '//' and remove trailing '/' from $masterroot
1 while $masterroot=~ s/\/\//\//g;
1 while $masterroot=~ s/\/$//g;
1 while $unitroot=~ s/\/\//\//g;
1 while $unitroot=~ s/\/$//g;



#$loginid=param('loginid');
#$unitShortName=param('unitshortname');
$file=param('file');
$root=param('root');
$mode=param('mode');
$item=param('item');

# unit-specific feedback directory
$feedbackdir="${feedbackrootdir}";
$namelistfile="${baseDirectory}/${unitShortName}_namelist.txt";

## read overriding security permissions e.g. $feedbackmasterpermission
# do "./config/${unitShortName}_feedback.rc";


# decompose path info
$root=${feedbackdir};
if($relativepath=~ /^\s*$/) { $relativepath=""; }
$file=absolutePath($root,$relativepath,$file);

# check for illegal characters
($validity,$combined)=validCharacters($file,$relativepath);
if(!$validity) {
  print "Content-type: text/html\n\n";
  print "Illegal characters in parameters [$combined].\n";
  exit 0;
}


# check for file permission
if(
   # always force the master permission check
   !permitted($masterpermission,$localpermission,$file)
   # then check against unit permission
   || !permitted($feedbackpermission,$localpermission,$file)
  ) {
  if(${file}=~ /^${root}(.*)$/) { $file="~$1"; }
  print "Content-type: text/html\n\n";
  print "Permission to [$file] denied.\n";
  exit 0;
}



# update the file if the $mode requests it
$fileUpdated=! updateFile($masterpermission,$feedbackpermission,$file,$mode);

$basename= `basename "$file"`;
$dirname=`dirname "$file"`;

if($basename=~/^([^\.]+)\.(.*)$/) { # weak definition of extension
    $propername="$1";
    $extension=".$2";
} elsif ($basename=~/^([^\.]+)$/) {
    $propername=$basename;
    $extension="";
} else {
    $propername="";
    $extension=$basename;
}
if($propername=~/^(.*\S)\s*$/) { $propername="$1"; }

# get student info from student name list
$details=getInfo($propername,$namelistfile);
$details=~ s/\s+/ /g;

# extract relative filename
if($file=~ /^${root}\/(.*)$/) {
    $properfile="$1";
} else {
    $properfile=$file;
}

# override CGI::url() to deal with SCIT's special web server
#sub CGI::url { return $ENV{'SCRIPT_URI'}; }
$submiturl=url()."?file=$properfile";


# html header
print "Content-type: text/html\n\n";
print "<html><head><title>Read File</title></head>\n";
print '<body bgcolor="#ffffff" text="#000000" link="#0000ff" alink="#999999" vlink="#999999">', "\n\n";

print <<EOF_STYLE
<style type="text/css">
a:link {  text-decoration: none; color:0000ff;}
a:active { text-decoration: none; color:3399ff;}
a:visited { text-decoration: none; color:60a0a0;}
//a:hover { text-decoration: none; color:ffd700; color:ff0000;}
a:hover{ background-color:#80e0e0; color:black; }
</style>
EOF_STYLE
    ;

print '<UL><!UL>&nbsp;';

print "<H1><B><font face='Arial, Helvetica, sans-serif'>FILE: &nbsp;<a href=\"${cgiscriptsite}/${viewfile_fb}?filetype=raw&link=no&file=$properfile\" title='view the file in html format'>$basename</a></font></B></H1>\n";


# $content=`cat "$file"`;
($notread,$timestamps,$content)=readFile($file);

print "<P><FORM Method=post name=EDITFILE action=\"$submiturl\">\n";
print "<b>ID:</b> <input name=id type=text size=10 onfocus='blur();' value='$propername'> &nbsp;\n";
print "<b>DETAILS:</b> <input name=details type=text size=40 onfocus='blur();' value='$details'>\n";
print "<input name=mode type=hidden value='update'>\n";
print "<input name=file type=hidden value='$file'>\n";
print "<input name=timestamps type=hidden value='$timestamps'>\n";
print "<input name=item type=hidden value='$item'>\n";
print "<p><TEXTAREA Name=\"content\" Rows=12 Cols=60>$content</TEXTAREA>\n";
print "<p><input type=button value='list students' title='go back to the student list' onclick='location=\"$cgiscriptsite/${feedback_fb}?item=${item}\";'> &nbsp;\n";
print "<input type=button onclick='reset();' title='reset text to previous state' value='reset'>";
print "<input type=button name=update title='save content and insert time stamp' onclick='submit();' ";
	 if($fileUpdated && $mode eq 'update') {
	     print "value='file now updated'>\n";
	 }
	 else { print " value='update file'>\n"; }
print "</form>";

	 print "\n<script>setTimeout(\"document.EDITFILE.update.value='update file';\",3000);</script>\n";



#############
# user defined subroutines
#############

use POSIX qw(strftime);

sub updateFile {
my($masterpermission,$feedbackpermission,$file,$mode)=@_;
if($mode ne 'update') { return 1; }

# check for file permission
if( !permitted($masterpermission,$localpermission,$file)
    || !permitted($feedbackpermission,$localpermission,$file) ) {
  return 2;
}

# create feedback subdirectory if not already in existence
if(! -d "$feedbackdir") {
  mkdir "$feedbackdir",0700;
}

if(!open(OUTPUT,">$file")) { return 3; }
flock(OUTPUT,2);  #2=LOCK_EX
print OUTPUT "# not read\n# ($loginid) ", strftime("%a %b %e %H:%M:%S %Y",gmtime), "\n";
my $timestamps=param('timestamps');
my $cr=chr(13);
$timestamps=~ s/$cr//g;
if($timestamps !~ /^\s*$/) { print OUTPUT "$timestamps\n"; }
my $content=param('content');
$content=~ s/$cr//g;
print OUTPUT $content;
flock(OUTPUT,8);  #8=LOCK_UN
close(OUTPUT);
chmod 0600, $file;
return 0;
}


sub readFile {
my($file)=@_;
my($notread,$timestamps,$content,$aline);
if(open(INPUTDATA,"<$file")) {
    while(<INPUTDATA>) {
	$aline="$_";
	if($aline=~ /^\s*(#.*)$/) {
	    if($aline=~ /not read/) {
		$notread=1;
	    } else {
		$timestamps .= $aline;
	    }
	} elsif($aline=~ /^\s*$/) {
	    next;
	} else {
            $content.=$aline;
	    while(<INPUTDATA>) {
		$content.="$_";
	    }
	}
    }
    close(INPUTDATA);
    return ($notread,$timestamps,$content);
}

   return (0, "", "");
}


sub getInfo {
my($id,$namelist)=@_;
my($details);
if(open(INPUT, "<$namelist")) {
    while(<INPUT>) {
	if(/^\s*$id\s+(.*)$/) {
	    $details="$1";
	    close(INPUT);
	    return $details;
	}
    }
    close(INPUT);
}
return $details;
}


# check for the permitted characters in form parameters
sub validCharacters {
my (@allParas)=@_;
my($onePara);
my($combined);
$combined=join(' ',@allParas);
for $onePara (@allParas) {
  if($onePara !~ /^[a-zA-Z0-9_\@\/\~\-\.\x2f\s:\x5c]*$/) {
    return (0,$combined);
  }
}
return (1,$combined);
}


# check for directory permission
sub permitted {
my($masterpermission,$localpermission,$dir)=@_;
  return ($dir ne "") && ($dir !~ /\.\./)

      # safty check to bar dirty trick users
      && ($dir =~ /^[a-zA-Z0-9_@\-\.\x2f\s:\x5c]*$/)
      # && ($dir =~ /^[a-zA-Z0-9_ \.\-\:\/]*$/)

      && withinPath($masterpermission,$dir)
      && !withinPath($savefiledisapproval,$dir)
      && ($localpermission eq "" || withinPath(localpermission,$dir)) ;
}


# check if dir is leading part of one of permissionpath separated by ":"
sub withinPath {
my($permissionpath,$dir)=@_;
my(@allpaths,$path);
  if("$dir" eq "") {
    return 0;
  }
  @allpaths=split(/:/, $permissionpath);
  foreach $path (@allpaths) {
    if($dir =~ m#^$path.*# ) {
      return 1;
    }
  }
  return 0;
}


# remove leading/trailing spaces, absorb "//", remove trailing "/"
sub absolutePath {
my($root,$relativepath,$dir)=@_;
my($absolute);
  if($dir=~/^\//) {
    $absolute=$dir;
  } else {
    $absolute="$root/$relativepath/$dir";
  }
  1 while $absolute=~ s/\/\//\//g;
  if($absolute=~/^(\/.*)\/$/) {
    $absolute="$1";
  }
  return $absolute;
}


sub pathAheadRelative {
my($tail)=@_;
my($head)="";
  if($tail=~/^(.*)\/([^\/]*)$/) {
    $head="$1";
    $tail="$2";
  }
  return ($head,$tail);
}

