#!/usr/bin/perl

# link marks files subdir to courses/${unitShortName}/marks;
# also update $displayQuizRecords below

do "./_conf-b.rc";
do "./_login-b.pl";

# load main configuration if not already loaded
if(!$CONFIG_LOADED) {
    do "./_conf-b.rc";
}

do "./_feedback.rc";
$viewfeedback="viewfeedback.pl";

# logfile for marks access
$logfile="${logfiledir}/access_misc.log";

$loginid=param('loginid');
$unitShortName=param('unitshortname');

# display temporary quiz records?
$displayQuizRecords=1;

# list student marks ranking?
$statistics=1;

# specific files
$namelistfile="$cgiscriptdir/config/${unitShortName}_namelist.txt";
$feedbackdir="$webhomedir/courses/${unitShortName}/feedback";
$quizstatedir="$webhomedir/courses/${unitShortName}/states";
$marksdir="$webhomedir/courses/${unitShortName}/marks";
$tutclassfile="$cgiscriptdir/config/${unitShortName}_tuts_reg.txt";

# tool to extract marks ranking
$calmarks="${cgiscriptdir}/support/calmarks.pl";
$grep="/bin/grep";


sub getTutClass {
my($tutclassfile,$studentid)=@_;
my($id,$classname,$rest);
  if($studentid=~/^\s*$/) {
      return "";
  }
  if(open(TUTS, "<$tutclassfile")) {
    while(<TUTS>) {
      $aline=$_;
      $id=$classname=$rest="";
      if($aline=/^\s*(\S+)\s+(\S+)\s+(.*)$/) {
	  $id="$1";
	  $classname="$2";
	  $rest="$3";
      } elsif ($aline=/^\s*(\S+)\s+(\S+)$/) {
	  $id="$1";
	  $classname="$2";
      }
      if($studentid eq $id && $classname ne "") {
        print "\n<br>Tutorial Class: ", $classname, "\n";
      }
    }
    close(TUTS);
  }
  return $classname;
}



sub getQuizMarks {
my($marksFile)=@_;
my($marks,$aline);
  if(open(MARKS, "<$marksFile")) {
    while(<MARKS>) {
      $aline=$_;
      if($aline=~/\[([^\]]*)\]/) {
        $marks=$1;
	last;
      }
    }
    close(MARKS);
  }
  return $marks;
}


sub showQuizMarks {
my($studentId,$marksDir)=@_;
my($first,$dir)=1;
  if(opendir(DIR, $marksDir)) {
    while(defined($dir=readdir(DIR))) {
      if($dir=~ /^state_${studentId}\.([^\~]*)$/) {
	if($first) {
	  $first=0;
	  print "<p><table border=1 width=320 rules=all _frame=hsides style='border-collapse: collapse;margin-top:5pt;margin-bottom:5pt;'>\n",
          "<tr><td colspan=2><font color=red face=courier><b>### ONLINE QUIZ RECORDS:</b></font></td></tr>\n",
          "<tr><td align=left>Quiz Session</td><td align=left>Correct in Last Trial</td></tr>\n";
	}
	print "<tr bgcolor=white onMouseOver=\"this.bgColor='#60c0c0';\" onMouseOut=\"this.bgColor='#ffffff';\">\n",
          "<td>$1</td><td>", getQuizMarks("${quizstatedir}/$dir"), "</td></tr>\n";
      }
    }
    if(!$first) {
      print "</table>\n";
    }
    close(DIR);
  }
}


sub pickStudentDetail {
my($id,$namelist)=@_;
my($aline,$details);
$details="";
if(open(NAMELIST, "<$namelist")) {
    while(<NAMELIST>) {
	$aline="$_";
	if(/^\s*(\S+)\s+(\S.*)$/) {
	    if($id eq "$1") {
                $details="$2";
		last;
	    }
	}
    }
    close(NAMELIST);
}
return $details;
}


sub listRecords {
my($id)=@_;
my($aline);

if(!chdir($feedbackdir)) { return; }
print "<table border=1 rules=all _frame=hsides style='border-collapse: collapse;margin-top:5pt;margin-bottom:5pt;'>\n";
if(open(FILELIST, "ls *${id}* 2>/dev/null|")) {

    my $messageDisplayed=0;
    while(<FILELIST>) {
        if(!$messageDisplayed) {
	    print "<tr><td colspan=2><font color=red face=courier><b>### MARKING FEEDBACK:</b></font></td></tr>\n";
	    $messageDisplayed=1;
	}

	$aline="$_";
        # must contain student ${id} at a word or "_" boundary
	if($aline !~ /(\b|_)${id}(\b|_)/) {
	    next;
	}

	$aline=~ tr/\n/ /;
	print "<tr title='view a student record' bgcolor=white style='cursor:pointer' onMouseOver=\"this.bgColor='#60c0c0';\" onMouseOut=\"this.bgColor='#ffffff';\" onclick=\"location='$cgiscriptsite/${viewfeedback}?file=${aline}';\">\n";
	print "<td align=center bgcolor=#80e0e0><a href='$cgiscriptsite/${viewfeedback}?method=download&file=${aline}' title='view comments file'> &nbsp; &nbsp;</a></td>\n";
	print "<td width=300 valign=top> &nbsp; $aline</td></tr>\n";
    }
    close(FILELIST);
}
print "</table>";
}

print "content-type: text/html\n\n";

print <<EOF_STYLE
<style type="text/css">
a:link {  text-decoration: none; color:0000ff;}
a:active { text-decoration: none; color:3399ff;}
a:visited { text-decoration: none; color:60a0a0;}
//a:hover { text-decoration: none; color:ffd700; color:ff0000;}
a:hover{ background-color:#ff0000; color:white; }

.title2 {
  background:#0066aa; color:white;
  padding-top:18pt; padding-bottom:18pt;
  padding-left:15pt; padding-right:15pt;
  font-size:2em; font-weight:900;
  font-family:sans-serif,Arial,Helvetica,sans-serif;
  text-align:left; text-transform:uppercase;
}

.padding {
  margin-top:1cm; margin-bottom:1cm;
  margin-left:0pt; margin-right:0pt;
}

</style>

<ul>

<div class=padding>
<span class=title2>
STUDENT RECORDS ($unitShortName)
</span></div>

EOF_STYLE
    ;


$details=pickStudentDetail($loginid,$namelistfile);
print "$loginid: $details\n";
getTutClass($tutclassfile, $loginid);

#print $tutclassfile, "=$loginid";

listRecords($loginid);

if ($displayQuizRecords) {
    showQuizMarks($loginid,$quizstatedir);
}

#$marksdir="/rusers/staff/zhuhan/Homepage/pp1/marks";
#$statistics=0;  # list ranking?
$studentid=$loginid;

print "<p><pre>\n";

while (<$marksdir/*.marks>) {
   open(FILE, "<$_") || next ;
   while(<FILE>) {
     $line=$_;

# print lines start with "##" or "#-"
     if(/\#[\#\-]/) {
	 print "<font size=+2 color=red face=courier><b>$line</b></font>";
     }
     elsif(/\#/) {
         print "<font size=+1 _size=-1 color=blue face=courier><b>$line</b></font>";
     }
     if(/\t($studentid)\t(.*)$/) {

         $line="$1\t$2";

	 if($line!~/\[/ && $line!~/\]/) { $line="$line [<font color=brown>0</font>]"; }

	 $line=~ s/\[/<font color=blue size=+2><b>\[marks /g;
	 $line=~ s/\]/\]<\/b><\/font>/g;
	 print "$line";
	 print "<UL>\n";

       while(<FILE>) {
         $line=$_;
         if(/^\s*$/) { last; }
         print "$line";
       }
	 print "</UL>\n";
    }
  }
  close(FILE);
}


if($statistics) {

print "</pre>\n";

$data=`$calmarks $marksdir/*.marks | $grep "$studentid" `;
if($data=~/^\s*\S+\s+\S+\s+(\S.*)$/) { $data="$1"; } else {$data="";}
if($data=~/^\s*\S+\s+(\d+)/) { $percent=$1; } else { $percent=100; }
if($percent>=60) { $color="green"; }
elsif($percent>=40) { $color="brown"; }
else {$color="red"; }

print "<b><font face=\"Arial, Helvetica, sans-serif\" color=green size=+3>SUMMARY</font></b>\n";
print "<table bgcolor=$color><tr><td><font color=yellow>\n";
print "<b>Rank/Percentage/Marks:</b><br>\n$data\n";
print "</font></td></tr></table>\n<p>";

}


print "<form><input type=button onclick=\"location='$cgiscriptsite/logout-b.pl';\" value=\"logout view records\"></form>";



sub writeLog {
my($uid,$sid,$ip,$message)=@_;
my($time)=time;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($time);
  $starttime=$time - eval($finishtime) + eval($starttime);
  $year=$year % 100;
  if($year<10) { $year="0$year"; }
  if(open(LOGFILE,">>$logfile")) {
    flock(LOGFILE, 2);
    print LOGFILE "$uid $sid, $time, $ip, $mday/",$mon+1,"/$year $hour:$min:$sec, $message\n";
    flock(LOGFILE, 8);
    close(LOGFILE);
    chmod 0600, "$logfile";
  }
}

$message="(marks)";
writeLog($loginid, $unitShortName,
$ENV{'REMOTE_ADDR'} . ":" . $ENV{'HTTP_X_FORWARDED_FOR'}, $message);
