#!/usr/bin/perl

#---------------------------------------------
# (c) Zhuhan Jiang
#     version 1.17  10 February 2010 (renamed 2.01)
# Freeware under GNU copyright convention.
#---------------------------------------------

############################################
# configurations: you may need to modify them
#############################################

# external configuration file
$externConfig="_conf-b.rc";

# where (which subdirectory) to keep the quiz states files
$stateDir="states/";   ### added: 2/01/2009

$allowQuizRepeats=0;
$viewNoSolutions=0;
$viewNoMarks=0;
$maxQuizQuestions=10;

# 1=eradicate possible collusion
# 0=allow multiple running on the same machine
$secureQuizMode=1;

# where password file and config file are kept
# $baseDir="c:/iwd2002/webquiz/";
$baseDir="./";

$quizPeriod=20*60;             # 20 minutes quiz
# $quizDir="/kusers/staff/zhuhan/Homepage/quiz/";  # quiz file directory
# $imageBase="http://www.cit.uws.edu.au/~zhuhan/quiz/images/";

## adaption for WINDOWS2000's IIS
# $quizDir="c:/iwd2002/webquiz/";
# $imageBase="http://nb-zhuhan.cit.uws.edu.au/webquiz/images/";
# $imageBase="http://localhost/webquiz/images/";

# change next line to make a new password for quiz administrator;
# use "webquiz.pl -p MyPassWord" to create a new string,
# or simply use $administrator=quickCrypt('MyPassWord');
$administrator="eC3Se5iK4JoAw";    # "administrator"
#$administrator=quickCrypt("administrator");

# add names/passwords to those who are allowed reset/restart a quiz,
# $administrator will be added automatically
%privileged=(
'privileged', "/iLDz6DgBhOIA",     # pswd="priviledged"
# 'zhuhan', quickCrypt('zjiang')   # more of the same
);

# you probably don't need to modify these
$passwordcrypt=1;           # 0=use in-house cryption, 1=use unix crypt()

#logfile record format:
#<UID> <SID>,<COMPUTENAME>:<IP>:<HOST>:<COOKIE-UID>:<COOKIE-SID>,
#<DATE>,<TIME> { [<MARKS>] | <OTHER INFO> }


# unit/purpose/duedate data
# *[*] <UNITNAME>, <UNITDIR>, <QUIZDIR>, <IMAGEURL>
# <PROJECTNAME>, <PROJDIR>, <DUEDATE>, <LATEDATE>
# **=default unit
#
$cfgtext=<<EOF_UNITS_AND_DUEDATES

** Interactive Website Development , IWSD, c:/iwd2002/webquiz/ , http://localhost/webquiz/images/
* Internet Computing , IC   # **=default

EOF_UNITS_AND_DUEDATES
;


###################################
# no modifications required below
# unless you know what you are doing
####################################



#include configuration file
do "${baseDir}$externConfig";

# fetch unit/purpose/duedates info
@cfgarray=split(/\n/,$cfgtext);


sub trim {
my($s)=@_;
  if($s=~/^\s*(.*\S)\s*$/) { return "$1"; }
  return "$s";
}


$defaultUnitCount=0;
$defaultUnitName="";

sub parseCfgX { # global: $defaultUnitCount, $defaultUnitName
my(@cfg)=@_;
my($data)=[];
my($count,$subcount)=(0,0);
my($title,$alias,$quizwhere,$imagewhere)=("","","","");
my($aline,$name,$due,$late);
my($entry)=[];
my($titlecount)=-1;
  foreach $aline(@cfg) {
    $name=$dir=$due=$late="";
    if($aline=~/^([^#]*)#.*$/) {
      $aline="$1";
    }
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^(.*)$/) { $aline="$1"; }
    $aline=~tr/a-zA-Z0-9[](){}<>+\-*\/,.:!?@#$%^&= ~/_/cs;
    if($aline=~/^([^,]*),(.*)$/) {
      $name="$1"; $aline="$2";
      if($aline=~/^([^,]*),(.*)$/) {
        $dir="$1";  $aline="$2";
        if($aline=~/^([^,]*),(.*)$/) {
          $due="$1";  $aline="$2";
          if($aline=~/^([^,]*),(.*)$/) {
            $late="$1";  $aline="$2";
          } else { $late=$aline; }
        } else { $due=$aline; }
      } else { $dir=$aline; }
    } else { $name=$aline; }
    $name=trim($name);
    $dir=trim($dir);
    $due=trim($due);
    $late=trim($late);
    if($name=~/^\*+\s*(.*)$/) {
      $aline="$1";
      $titlecount++;
      if($name=~/^\*\*/) {
        $defaultUnitCount=$titlecount;
        $defaultUnitName=$aline;
      }
      # $name="$1";
      $name=$aline;
      if($title ne "") {
        $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere];
      }
      $title=$name; $alias=$dir;
      $quizwhere=$due; $imagewhere=$late;
      $subcount=0;
      $entry=[];
    }
    else {
      $entry->[$subcount++]=[$name,$dir,$due,$late];
    }
  }
  if($#cfg>=0) { $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere]; }
  return $data;
}


sub cvtCfgX{ # global: $defaultUnitCount
my($data,$unit)=@_;
my($i,$j,$name,$entry);
my(%unitmap)=();
my(%purposemap)=();
my(%duedate)=();
my(%latedate)=();
my(%quizdirmap)=();
my(%imagebasemap)=();
  $i=0;
  if(!defined($unit)) { $unit=""; }
  while(1) {
    $entry=$data->[$i];
    if(!defined($entry)) { last; }
    $name=$entry->[0];
    $unitmap{"$name"}=$entry->[1];
    $quizdirmap{"$name"}=$entry->[3];
    $imagebasemap{"$name"}=$entry->[4];
    if("$name" eq "$unit" || $i==$defaultUnitCount && "$unit" eq "") {
      $entry=$entry->[2];
      $j=0;
      while(1) {
        if(!defined($entry->[$j])) { last; }
        $name=$entry->[$j][0];
        $purposemap{"$name"}=$entry->[$j][1];
        $duedate{"$name"}=$entry->[$j][2];
        $latedate{"$name"}=$entry->[$j][3];
        $j++;
      }
    }
    $i++;
  }
  return (\%unitmap,\%quizdirmap,\%imagebasemap,\%purposemap,\%duedate,\%latedate);
}


# get %unitmap etc
@cfgXParsed=parseCfgX(@cfgarray);
if(param('unitname') eq "") {
  param(-name=>'unitname',-default=>$defaultUnitName);
}
(*unitmap,*quizdirmap,*imagebasemap)=cvtCfgX(@cfgXParsed,param('unitname'));


sub getQuizName {
my($sid)=@_;
  return "quiz.$sid";
}


sub getSessionName {
my($qfile)=@_;
my($session);
  if($qfile=~/^quiz\.(.*)$/) {
    $session="$1";
  }
  return $session;
}


sub getSessionView {  #check if access file entry contains # view solution
my($sid,$fname)=@_;
my($view,$repeat)=(0,0);
  if(open(SESSION,"<$fname")) {
    while(<SESSION>) {
      if(/^\s*$sid\s+[^\#]*\#.*view\s+solution.*$/) {
	$view=1;
      }
      if(/^\s*$sid\s+[^\#]*\#.*repeat\s+session.*$/) {
	$repeat=1;
      }
    }
    close(SESSION);
  }
  return ($view,$repeat);
}


sub getFileNames {
# map uid/sid to quiz filenames
my($uid,$sid)=@_;
my(@files)=(getQuizName($sid), "${stateDir}state_$uid.$sid", "solution.$sid"); ### updated: 2/01/2009
  return @files;
}

#################
## no reconfigurations needed for the code below
#################

$privileged{'administrator'}=$administrator;

sub quickCrypt {
my($password)=@_;
my($set,$length,$salt);
  $set="ABCDEFGHIJKLMNOPQRSTUVWXYZ./0123456789";
  $set=$set.lc(substr($set,0,26));
  $length=length($set);
  $salt= substr($set,rand($length),1).substr($set,rand($length),1);
  return crypt($password,$salt);
}


sub isAdministrator { # global: $administrator
my($password)=@_;
  if(crypt($password,$administrator) eq "$administrator") {
    return 1;
  }
  return 0;
}


sub privilegedName { # global %privileged
my($password)=@_;
my($key,$value);
  foreach $key (keys %privileged) {
    $value=$privileged{"$key"};
    if(crypt($password,$value) eq "$value") {
      return "$key";
    }
  }
  return "";
}


sub codePassword {
my($rawpasswd)=@_;
my($a,$b,$c,$d,$i);
my(@num)=();
  for($i=0;$i<8;$i++) { $num[$i]=ord(substr("$rawpasswd",$i,1)); }
  $a=chr($num[0]);
  $b=chr($num[1]);
  for($i=1;$i<8;$i++) {
    if($num[$i]==32) {
      $num[$i]=$i+97;
      if($i==1) { $b="B"; }
    }
  }
  $c=$d=0;
  for($i=0;$i<4;$i++) {
    $c+=$num[2*$i];
    $d+=$num[2*$i+1];
  }
  return $a.$c.$b.$d;
}


sub checkPassword {
my($uid,$rawpasswd,$pfile)=@_;
my($passwd)=codePassword($rawpasswd);
my($aline,$ppasswd,$psubdir,$puid);
my($matched)=0;
  if(open(PASSFILE, "<$pfile")) {
    while(<PASSFILE>) {
      $aline=$_;
      ($ppasswd,$psubdir,$puid) = split(/,/, $aline);
      if($puid=~ /^(.*)\n$/) { $puid="$1"; }
      if($ppasswd eq $passwd  && $puid eq $uid) {
        $matched=1;
        last;
      }
    }
    close(PASSFILE);
  }
  return $matched;
}


sub checkCryptPassword {
my($uid,$rawpasswd,$pfile)=@_;
my($aline,$ppasswd,$psubdir,$puid);
my($matched)=0;
  if(open(CRYPTPASSFILE, "<$pfile")) {
    while(<CRYPTPASSFILE>) {
      $aline=$_;
      ($puid,$ppasswd,$psubdir) = split(/,/, $aline);
      if($psubdir=~ /^(.*)\n$/) { $psubdir="$1"; }
      if("$puid" eq "$uid" && crypt($rawpasswd,$ppasswd) eq "$ppasswd") {
        $matched=1;
        last;
      }
    }
    close(CRYPTPASSFILE);
  }
  return $matched;
}


sub passwordOk { # global: $passwordfile
my($uid,$password,$useCrypt)=@_;
  return $useCrypt?
    checkCryptPassword($uid,$password,$passwordfile)
    : checkPassword($uid,$password,$passwordfile);
}


sub getParas {
# must use $cgi->Vars instead if CGI.pm is loaded
my($buffer,$pair,$nvpairs,$name,$value);
my(%form);
  if($ENV{'REQUEST_METHOD'} eq "GET") {
    $buffer=$ENV{'QUERY_STRING'};
  }
  else { read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); }
  @nvpairs=split(/&/,$buffer);
  foreach $pair (@nvpairs) {
    ($name,$value)=split(/=/,$pair);
    $value=~ tr/+/ /;
    $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
    $form{$name}=$value;
  }
  return %form;
}


sub readState { #global: $quizDir,$quizPeriod
my($fname,$clock,$period)=@_;
my($aline);
my(%state)=();
my($time)=time;
  if(eval($period) == 0) { $period=$quizPeriod; }
  $state{'0'}="$period,$time,$clock,$xid,";
  if(open(STATEIN, "<$quizDir$fname")) {
    while(<STATEIN>) {
      $aline=$_;
      if($aline=~/(\d+):(.*)$/) {
        $state{"$1"}="$2";
      }
    }
    close(STATEIN);
  }
  return %state;
}


sub readInfo {
my($fname,$qnum)=@_;
my(%state,$info);
my($type,$value)=("","");
  %state=readState($fname);
  $info=$state{"$qnum"};
  if($info=~ /^([^:]*):(.*)$/) {
    $type="$1";
    $value="$2";
  }
  return ($info,$type,$value);
}


sub stateInfo {
my($fname)=@_;
my($info)=readInfo($fname,0);
my($wid,$date,$ip);
  if($info=~/^[^,]*,[^,]*,[^,]*,([^,]*),([^<]*)<[^:]*:([^:]*):([^:]*):/) {
    $wid="$1";
    $date="$2";
    $ip="$3";
    $uid="$4";
  }
  return ($wid,$date,$ip,$uid);
}


sub isStateLocked {
my(%state)=@_;
my($locker)=$state{'00'};
  if($locker ne "") { return 1; }
  else { return 0; }
}


sub isLocked {
my($sfile)=@_;
my(%state)=readState($sfile);
  return isStateLocked(%state);
}


sub lockState { # return 1=did something
my($sfile,$marks)=@_;
my(%state)=readState($sfile);
  if(isStateLocked(%state)) { return 0; }
  $state{'00'}="[$marks]";
  writeRawState($sfile,\%state,0,"<$clientinfo>");
  return 1;
}


sub writeState { # %state must be passed by reference
local($fname,*state,$chktime,$message)=@_;
  if(isLocked($sfile)) { return 0; }
  return writeRawState($fname,\%state,$chktime,$message);
}

sub writeRawState { #global: $quizDir
# %state must be passed by reference
local($fname,*state,$chktime,$message)=@_;
my($time)=time;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($time);
my($oldtime)=$time;
my($period)=0;  # no limit
my($aline,$key);
my($clock)=$FORM{'clock'};
my($wid)=$xid;

  if($chktime eq "") { $chktime=0; }
  $aline=$state{'0'};
  if($aline=~/^\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*([a-zA-Z0-9]+).*$/) {
    $period=eval($1);
    $oldtime=eval($2);
    $clock=eval($3);
    $wid="$4";
  }
  if($chktime) {
    if($time-$oldtime > $period) { #timeout
      return 0;
    }
  }
  if($wid ne $xid) {
    # param(-name=>'msg', -default=>'multiple concurrent sessions attempted');
    return 0;
  }

  if(open(STATEOUT,">$quizDir$fname")) {
    flock(STATEOUT,2);  #2=LOCK_EX
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($oldtime);
    $year=$year % 100;
    if($year<10) { $year="0$year"; }
    $state{'0'}="$period,$oldtime,$clock,$wid,$mday/". ($mon+1) ."/$year $hour:$min:$sec $message";
    foreach $key (sort(keys %state)) {
      print STATEOUT "$key:" . $state{"$key"} . "\n";
    }
    flock(STATEOUT,8);  #8=LOCK_UN
    close(STATEOUT);
    chmod 0600, "$quizDir$fname";
  }
  return 1;  # successful
}


sub cmpRecord {
my($one,$two)=@_;
my($rest);
  if($one=~/^([^\|]*)\|(.*)$/) {
    $rest="$2";
    return cmpRecord("$1","$two") || cmpRecord("$rest","$two");
  }
  elsif($two=~/^([^\|]*)\|(.*)$/) {
    $rest="$2";
    return cmpRecord("$1","$one") || cmpRecord("$rest","$one");
  }
  else {
    return cmpRawRecord("$one","$two");
  }
}


sub cmpRawRecord {
my($one,$two)=@_;
my($typeone,$typetwo,$valueone,$valuetwo);
  if("$one" eq "$two") { return 1; }
  if($one=~/^([^:]*):(.*)$/) {
    $typeone="$1";
    $valueone="$2";
    if($two=~/^([^:]*):(.*)$/) {
      $typetwo="$1";
      $valuetwo="$2";
      if($typeone eq "t"
         || $typeone eq "T" ) {
        $valueone=~ s/\s+/ /g;
        $valuetwo=~ s/\s+/ /g;
        $valueone=~ s/^\s+//g;
        $valueone=~ s/\s+$//g;
        $valuetwo=~ s/^\s+//g;
        $valuetwo=~ s/\s+$//g;
        if($typeone eq "T") {
          $valueone=~ tr/[a-z]/[A-Z]/;
          $valuetwo=~ tr/[a-z]/[A-Z]/;
        }
      }
      # remove non-important white spaces for programming statements;
      # just delete next 4 lines if you don't want this
      $valueone=~ s/([^_0-9a-zA-Z])\s+/$1/g;
      $valueone=~ s/\s+([^_0-9a-zA-Z])/$1/g;
      $valuetwo=~ s/([^_0-9a-zA-Z])\s+/$1/g;
      $valuetwo=~ s/\s+([^_0-9a-zA-Z])/$1/g;

      return ("$valueone" eq "$valuetwo")?1:0;
    }
  }
  return 0;
}


sub cmpState {
local(*one,*two)=@_;
my($result)=0;
my($key,$value,$valueone,$valuetwo);
  foreach $key (keys %one) {
    $value=eval($key);
    if($value>0) {
      $valueone=$one{"$key"};
      $valuetwo=$two{"$key"};
      if(cmpRecord($valueone,$valuetwo)) { $result++; }
    }
  }
  return $result;
}


sub getRawQuiz { #global: $quizDir
# return: $info=solution, $content=quiz text
my($fname,$qnum)=@_;
my($count)=0;
my($content)="";
my($digits)="";
my($info)="";
my($aline);
my($type,$value)=("","");
  if(!defined($qnum) || $qnum eq "") { $qnum=-1; }
  if(open(QUIZ,"<$quizDir$fname")) {
    while(<QUIZ>) {
      $aline=$_;
      if($aline=~/^\s*<!--quiz-(\d*)-(.*)-->\s*$/) {
        $count++;
        if($count==$qnum) {
          $digits="$1";
          $info="$2";
        }
        next;
      }
      if($count>$qnum) { last; }
      elsif($count==$qnum) {
        $content="$content" . "$aline";
      }
    }
    close(QUIZ);
  }
  $content=~ s/^\s+//g;
  if($digits eq "") { $content=$info=""; }
  if($info=~/^([^:]*):(.*)$/) {
    $type="$1";
    $value="$2";
  }
  return ($content,$info,$type);
}


sub extractSolutions { #
# allowed time period=0 (always timeout when treat as sfile)
my($fname)=@_;
my($count)=0;
my($value);
my(%state)=();
  if(open(QUIZ, "<$quizDir$fname")) {
    while(<QUIZ>) {
      if(/^\s*<!--quiz-(\d+)-(.*)-->\s*$/) {
        $count++;
        $value="$2";
	$value=~ s/\&lt\;/</g;
	$value=~ s/\&gt\;/>/g;
	$value=~ s/\&amp\;/\&/g;
	$value=~ s/\&quot\;/\"/g;
        $value=~ s/^\s+//g;
        $value=~ s/\s+$//g;
        $state{"$count"}="$value";
      }
    }
    close(QUIZ);
  }
  return %state;
}


sub saveSolutions {
my($fnameIn,$fnameOut)=@_;
my(%state)=extractSolutions($fnameIn);
my(@keys)=keys %state;
  if($#keys<0 || $fnameOut eq "") { return 0; }
  writeState($fnameOut,\%state,0,"[" . ($#keys+1) ."]");
  lockState($fnameOut,0);
}


sub setInitValue {
my($text,$info)=@_;
my($type,$value,$result,$property,$rest,$char,$i);
my(@items);

  if($info=~/^\s*([^:]+):(.*)$/) {
    $type="$1";
    $type=~ tr/[a-z]/[A-Z]/;
    $value="$2";
  }
  if($type eq "T") {
    # $value=~ tr/\"/\'/;
    $value=~ s/\"/&quot\;/g;
    $value=~ s/\|T:/\|/g;
    $value=~ s/\|t:/\|/g;
  }

  $text=~ s/<input\s/<input /sgi;
  @items= split(/<input /, $text);
  for($i=1; $i<=$#items; $i++) {
    if($type eq "T") {
      if($items[$i]=~ /^([^<>]*)>(.*)$/s) {
        $property=" $1 ";
        $rest="$2";
        $property=~ s/\s*value\s*=\s*\S+\s*/ value=\"$value\" /gi;
        $items[$i]="$property>$rest";
      }
      last;
    }
    $char=chr(ord('A')+$i-1);
    if($value=~/$char/) {
      $items[$i]="checked " . $items[$i];
    }
   }
  $result="";
  for($i=0; $i<=$#items; $i++) {
    if($i==0) { $result=$items[0]; next; }
    $result=$result . "<input " . $items[$i];
  }
  return $result;
}


# ENCTYPE="multipart/form-data"
sub makeQuiz {  # global: $unitname, $pid
my($qfile,$sfile,$qnum)=@_;
my($content,$info,$type,$result);
  ($content,$info,$type)=getRawQuiz($qfile,$qnum);
  ($info)=readInfo($sfile,$qnum);
  $content=setInitValue($content,$info);
  $result="content-type: text/html\n\n<html><head><BASE href=\"$imageBase\"></head><body>\n";
  if($content!~/^\s*$/) {
    $result=$result . "<form method=post action=\"$submiturl\" ENCTYPE=\"multipart/form-data\">\n"
       . $content
       . "</p>"
       . "<input type=hidden name=unitname value=\"$unitname\">\n"
       . "<input type=hidden name=pid value=\"$pid\">\n"
       . "<input type=hidden name=qfile value=\"$qfile\">\n"
       . "<input type=hidden name=sfile value=\"$sfile\">\n"
       . "<input type=hidden name=qnum value=\"$qnum\">\n"
       . "<input type=hidden name=type value=\"$type\">\n"
       . "<input type=hidden name=mode value=\"run\">\n"
       . "<input type=hidden name=list value=\"refresh\">\n"
       . "<input type=submit name=submit value=update></form>\n";
  }
  $result=$result . "</body></html>\n";
  return $result;
}


sub getAnswer {
# form parameters passed as %items
my(%items)=@_;
my($answer)="";
my($key,$value,$choice,$type,$i);
  $choice=$items{'choice'};
  $type=$items{'type'};
  if($type=~/^R$/i) { return $choice; }
  for($i=ord('A'); $i<=ord('Z'); $i++) {
    $key=chr($i);
    $value=$items{$key};
    if($value ne "") {
      if($answer ne "" ) {
        $answer=$answer . ",";
      }
      $answer=$answer . $value;
    }
  }
  return $answer;
}


sub updateQuiz { #global: $clientinfo
my($fname,$qnum,%items)=@_;
my($answer)=getAnswer(%items);
my($type)=$items{'type'};
my($clock)=$items{'clock'};
my(%state)=readState($fname,$clock);
  if($type ne "") {
    if($type eq 't' || $type eq 'T') {
      if($answer=~ /^([^\|]*)\|/) {
        $answer="$1";  # accepting only 1st option
      }
    }
    $state{"$qnum"}="$type:$answer";
  }
  if(isStateLocked(%state)) { return 0; }
  return writeState($fname,\%state, 1, "<$clientinfo>");
}


sub checkQuiz {
my(%items)=@_;
my($qfile)=$items{'qfile'};
my($sfile)=$items{'sfile'};
my($qnum)=$items{'qnum'};
my($uninitiated)= (-z "$quizDir$sfile");
my($updated)=updateQuiz($sfile,$qnum,%items);
  print makeQuiz($qfile,$sfile,$qnum);
  #comment off the condition below will display clock at more appropriate time
  #but may irritate eyes
  if($items{'list'} eq 'refresh' || $uninitiated ) {
    print "<script language=javascript>parent.frames['LIST'].location.reload();</script>\n";
  }
  if(!$updated) {
    if(cookie('finish'.$pid) ne cookie('uid'.$pid)) {
      my($wid,$date,$ip,$uid)=stateInfo($sfile);
      print "<p><font color=red size=+3>&#9760;</font>CONTROL LOST TO: <br>ip=$ip, uid=$uid, xid=$wid at $date";  ## windings: &#77
    }
    print "<script language=javascript>top.status='Quiz now timed out or finished';</script>\n";
  }
}


sub getCount { #global: $quizDir
my($fname)=@_;
my($count)=0;
  if(open(QUIZ,"<$quizDir$fname")) {
    while(<QUIZ>) {
      if(/^\s*<!--quiz-\d+-.*-->\s*$/) { $count++; }
    }
    close(QUIZ);
  }
  return $count;
}


sub solutionIndex {
my($qfile,$sfile,$afile,$columns)=@_;
my(%state)=readState($sfile);
my(%solution)=readState($afile);
my($status,$color,$count,$i);
my($width)=60*$columns;
my($result)="";
#  $count=getCount($qfile);
  $result="content-type: text/html\n\n"
         . "<html><body>\n"
         . "<font face='Arial, Helvetica, sans-serif' size=+1><b>SOLUTIONS:</b></font><p>\n"
         . "<form method=post name=ARUN action=$submiturl target=QUIZ>\n"  ##<<<
         . "<input type=hidden name=unitname value=\"$unitname\">\n"
         . "<input type=hidden name=pid value=\"$pid\">\n"
         . "<input type=hidden name=qnum value=\"\">\n"
         . "<input type=hidden name=mode value=run>\n"
         . "<input type=hidden name=qfile value=\"$qfile\">\n"
         . "<input type=hidden name=sfile value=\"$afile\">\n"  ##>>>
         . "<table border=1>\n";

  my $seeds=$cgi->cookie('seeds'.$pid);
  my @seedList=split(/,/,$seeds);
  my $j=0;
  $count=$#seedList+1;
#  for($i=1;$i<=$count;$i++) {
  for $i (@seedList) {
    $j++;
    $status= cmpRecord($state{"$i"},$solution{"$i"})? "ok":"x";
    $color=$status ne "x"? "yellow":"pink";
    if($columns==1 || $j % $columns==1) { $result=$result . "<tr>\n"; }
    $result=$result
      ## . "<td align=center width=20><a href=${submiturlQuery}mode=run&qnum=$i&qfile=$qfile&sfile=$afile target=QUIZ>$i</a></td>\n"
      . "<td align=center width=20><a href=$submiturl target=QUIZ onclick=\"document.ARUN.qnum.value='$i';document.ARUN.submit();return false;\">$j</a></td>\n"
      . "<td bgcolor=$color width=20 align=center>$status</td>\n";
  }
  if($columns==1 || $j % $columns==0 || $j==$count) { $result=$result . "</tr>\n"; }
  $result=$result . "</table>\n</body></html>\n";
  return $result;
}


sub makeIndex {
my($qfile,$sfile,$afile,$columns)=@_;
my(%state)=readState($sfile);
my($status,$color,$count,$i);
my($width)=60*$columns;
my($result)="";
#  $count=getCount($qfile);
  $result="content-type: text/html\n\n"
         . "<html><body>\n"
         . "<font face='Arial, Helvetica, sans-serif' size=+1><b>QUESTIONS:</b></font>\n"
         . makeClock($sfile)
         . "<form method=post name=QRUN action=$submiturl target=QUIZ>\n"  ##<<<
         . "<input type=hidden name=unitname value=\"$unitname\">\n"
         . "<input type=hidden name=pid value=\"$pid\">\n"
         . "<input type=hidden name=qnum value=\"\">\n"
         . "<input type=hidden name=mode value=run>\n"
         . "<input type=hidden name=qfile value=\"$qfile\">\n"
         . "<input type=hidden name=sfile value=\"$sfile\">\n"   ##>>>>
         . "<input type=hidden name=clock value=\"\">\n"
         . "<table border=1 width=$width>\n";

  my $seeds=$cgi->cookie('seeds'.$pid);
  my @seedList=split(/,/,$seeds);
#  for($i=1;$i<=$count;$i++) {
  my $j=0;
  $count=$#seedList+1;
  for $i (@seedList) {
    $j++;
    $status= $state{"$i"} ne ""? "<font face=courier>&#9788;</font>":"&nbsp;"; ## wingdings: &#79
    $color=$status ne "&nbsp;"? "cyan":"red";
    if($columns==1 || $j % $columns==1) { $result=$result . "<tr>\n"; }
    $result=$result
       ## . "<td align=center width=20><a href=${submiturlQuery}mode=run&qnum=$i&qfile=$qfile&sfile=$sfile target=QUIZ>$i</a></td>\n"
      . "<td align=center width=20><a href=$submiturl target=QUIZ onclick=\"document.QRUN.qnum.value='$i';document.QRUN.clock.value=Math.floor(new Date().getTime()/1000);document.QRUN.submit();return false;\">$j</a></td>\n"
      . "<td bgcolor=$color width=20 align=center>$status</td>\n";
    if($columns==1 || $j % $columns==0 || $j==$count) { $result=$result . "</tr>\n"; }
  }
  $result=$result . "</table>\n</body></html>\n";
  return $result;
}


sub listQuiz {   # global: $accessfile
my(%items)=@_;
my($qfile)=$items{'qfile'};
my($sfile)=$items{'sfile'};
my($afile)=$items{'afile'};
my($how)=$items{'how'};
my($finish)='Review';
my($sid)=getSessionName($qfile);
my($viewSolution)=getSessionView($sid,$accessfile);
  if("$how" ne "view") {
    print makeIndex($qfile,$sfile,$afile,2);
    $how='view';
    $finish='Finish';
  }
  else {
    if($viewNoSolutions && !$viewSolution) {
      print makeIndex($qfile,$sfile,$afile,2);
    } else {
      print solutionIndex($qfile,$sfile,$afile,2);
    }
    $how='';
  }
  print "<p><nobr><span title='pid=" . $pid .", xid=" . cookie('xid'.$pid)
   . "'><font face=courier>&#9755;</font>&nbsp;<font size=-1>IDs: "  ## wingdings: &#255;
   . cookie('uid'.$pid) . "/" . cookie('sid'.$pid) . "</font></span></nobr>"
   . "<br><font face=courier>&#10065;</font>&nbsp;<a "  ## wingdings: &#48;
   . "href=${submiturlQuery}mode=finish&how=$how&qfile=$qfile&sfile=$sfile&afile=$afile target=QUIZ>$finish</a>\n"
   . "<br><font face=courier>&#9678;</font>&nbsp;<a href=\"\" onclick=\"document.location.reload();return false;\">Refresh</a>\n";  ## wingdings: &#36;
  if("$how" ne "view") {
    print "<P><font face=courier>&#9993;</font>&nbsp;<a href=${submiturlQuery}mode=logout>Logout</a>\n"; ## wingdings: &#42;
  }
  print "<p>&nbsp;<p><font color=black size=-1>ver 2.01, 2012<br><font size=+0>&copy;</font>&nbsp;<font size=-2>ZHUHAN JIANG</font></font>";
}


sub markQuiz {
local($cgi,*items)=@_;
my($qfile)=$items{'qfile'};
my($sfile)=$items{'sfile'};
my($afile)=$items{'afile'};
my($how)=$items{'how'};
my(%state)=extractSolutions($qfile);
my(%student)=readState($sfile);
my($count)=getCount($qfile);
my($marks)=cmpState(\%state, \%student);
my($uid,$sid,$finish,$cookie);
my($agent)=$ENV{'HTTP_USER_AGENT'};
  $uid=$cgi->cookie('uid'.$pid);
  $sid=$cgi->cookie('sid'.$pid);
  if(lockState($sfile,$marks)) { logEvent("$uid","$sid","[$marks]"); }
  $finish=$cgi->cookie('finish'.$pid);
  $cookie=$cgi->cookie(-name=>'finish'.$pid, -value=>"$uid", -expires=>'+60m');
  print $cgi->header(-cookie=>"$cookie", -type=>'text/html');
  if($viewNoMarks) {
    print "The Quiz is now completed.\n";
  } else {
    if($count>$maxQuizQuestions) { $count=$maxQuizQuestions; }
    print "The marks are [$marks] out of [$count].\n";
  }
  print "\n"
   . "<script language=javascript>\n"
   . "<!---\n"
   . "parent.frames['LIST'].location.href='${submiturlQuery}mode=list&how=$how&qfile=$qfile&sfile=$sfile&afile=$afile';\n"
   . "timerId=setInterval(\"";
  if($agent!~/MSIE/) {
    print "parent.frames['LIST'].reload();";
  }
  else {
    print "parent.frames['LIST'].location.reload();";
  }
  print "\", 500);\nclearInterval(timerId);\n"
   . "//--->\n"
   . "</script>\n";
}


sub getCookies {
my($cgi)=@_;
my(@cname)=("uid","sid","xid","qfile","sfile","afile");
my(%clist)=();
my($name,$i);
  for($i=0;$i<=$#cname;$i++) {
    $name=$cname[$i];
    $clist{"$name"}=$cgi->cookie("$name$pid");
  }
  return %clist;
}


sub logonPage {
local($cgi,*items)=@_;
my($uid)=$cgi->cookie('uid'.$pid);
my($msg)=$items{'msg'};
my($sid)=$items{'sid'};
my($key,$count);
  print "content-type: text/html\n\n<html><body>\n"
   . "<form name=SUBMIT method=post action=$submiturl ENCTYPE=\"multipart/form-data\">\n"
   . "<table cellpadding=30 bgcolor=" . $mainBackgroundColor . "><tr><td>\n"
   . "<input type=hidden name=via value=logonpage>\n"
   . "<input type=hidden name=mode value=frame>\n"
   . "<input type=hidden name=pid value=\"$pid\">\n"
   . "<input type=hidden name=xid value=\"$xid\">\n"
   . "<table border=0>\n"
   . "<tr><td colspan=2 align=center><font face='Arial, Helvetica, sans-serif' size=+3><b>ONLINE QUIZ</b></font></td></tr>\n"
   . "<tr><td>&nbsp;</td></tr>";


  print "<tr><td align=right>UNIT NAME:&nbsp;\n<select name=\"unitname\" onchange=\"document.SUBMIT.mode.value='logon';document.SUBMIT.submit();\">\n";
  if(param('unitname') ne "") {
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if( "$key" eq param('unitname') ) { print " selected "; }
        print ">$key\n";
    }
  } else { # no explict request
    $count=0;
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if($count++==$defaultUnitCount) { print " selected "; }
        print ">$key\n";
    }
  }
  print "</select>\n</td><td width=40>&nbsp; </td></tr>\n";


  print
     "<tr><td align=right>STUDENT ID:&nbsp;<input type=text name=uid value=\"\" size=30 maxlength=30>&nbsp;</td><td width=40>&nbsp; </td></tr>\n"
   . "<tr><td align=right>PASSWORD:&nbsp;<input type=password name=password value=\"\" size=30 maxlength=30>&nbsp;</td></tr>\n"
   . "<tr><td align=right align=right>SESSION:&nbsp;<input type=text name=sid value=\"$sid\" size=3 maxlength=8 title=\"must fill this field\">\n";

  if($allowQuizRepeats) {
    print " &nbsp;REPEAT:<input type=checkbox name=repeat value=repeat checked>\n";
  }

  print
     " &nbsp;&nbsp;KEY: &nbsp;<input type=password name=key size=6 maxlength=20 title=\"leave this field blank unless you know the key\">&nbsp;</td></tr>\n"
   . "<tr><td align=right><font size=-2>ADMINISTRATOR</font><input type=checkbox name=admin value=yes title=\"admin only\">&nbsp;\n"
   . "<font size=-2>RESET</font><input type=checkbox name=delete value=delete title=\"admin only\">&nbsp;\n"
   . "<font size=-2><i>ACCESS</i></font><input type=checkbox name=access value=yes title=\"admin only\">&nbsp;\n"
   . "<font size=-2><i>ON</i></font><input type=radio name=onoff value=on title=\"admin only\">\n"
   . "<font size=-2><i>OFF</i></font><input type=radio name=onoff value=off title=\"admin only\">\n"
   . "</td></tr><tr><td align=right>\n"

#   . "<input type=button value='restart' onclick=\"location='$submiturl?pid=$pid&mode=logout';\">", "&nbsp;\n"

   . "<input type=button name=logout onclick=\"if(self==top)window.open('${submiturlQuery}mode=logout','','dependent=no,resizable,location,personalbar,scrollbars,menubar,status,titlebar,toolbar');top.close();\" value=\"secure logout\" title=\"clear last session if you didn't logout last quiz properly\">&nbsp;\n"
  . "<input type=submit _name=submit value=\"logon quiz\" title=\"start the quiz\"></td></tr>\n"
   . "<tr><td align=right>ver 2.01 &copy; <font size=-2>2012 ZHUHAN JIANG</font></td></tr>\n";
 if($msg!~/^\s*$/) {
   print "<tr></tr><td>&nbsp;</td><tr><td bgcolor=red colspan=2 align=center><font color=white>$msg</font></td></tr>\n";
 }

 if("$uid" ne "") {
#   print "<tr><td align=right><a href=\"${submiturlQuery}mode=logout\">logout $uid</a></td></tr>\n";
 }
 print "</table>\n"
   . "</td></tr></table>\n"
   . "</form>\n</body></html>\n";
}


sub framePage {
my(%items)=@_;
my($qfile)=$items{'qfile'};
my($sfile)=$items{'sfile'};
my($afile)=$items{'afile'};
  print "content-type: text/html\n\n"
   . "<frameset cols=\"160,*\">\n"
   . "<frame src=\"${submiturlQuery}mode=list&qfile=$qfile&sfile=$sfile&afile=$afile\" name=LIST>\n"
   . "<frame src='javascript:document.write(\"<font size=-1><i>Your existing record for this quiz, if any, has now been deleted.</i></font><br><font size=+2>Click a question number to start.</font>\");document.close();' name=QUIZ>\n"
   . "</frameset>\n"
}


sub authenticated {
local($cgi,*items,*cookies)=@_;
my($key,$value,$param);
my(@cookienames)=(#"uid","sid",
                     "qfile","sfile","afile");
  $value=$cgi->cookie('finish'.$pid);  # old %cookies has no 'finish'.$pid
  $param=$cookies{'uid'};
  if("$value" ne "" && "$value" eq "$param") { return 1; } #user finished
  foreach $key (@cookienames) {
    $value=$cookies{"$key"};
    if("$value" eq "") { return 0; }
    $param=$items{"$key"};
    if($param ne "" &&  "$value" ne "$param") {
      return 0;
    }
  }
  return 1;
}


sub getQuestionSeeds {
my($qfile,$length)=@_;  # seeds contains $length number of items
my($total);
my(@list,$seeds,$i);
  $total=getCount($qfile);
  if($length>$total) { $length=$total; }
  @list=rawRandomArray($total,$length);
  $seeds="";
  for $i (@list) {
    if($seeds eq "") {
      $seeds="$i";
    } else {
      $seeds.=",$i";
    }
  }
  return $seeds;
}


sub setCookies {
my($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile)=@_;
my($c1,$c2,$c3,$c4,$c5,$c6,$c7);
my($c8,$seeds);
  $c1=$cgi->cookie(-name=>'qfile'.$pid, -value=>"$qfile", -expires=>'+120m');
  $c2=$cgi->cookie(-name=>'sfile'.$pid, -value=>"$sfile", -expires=>'+120m');
  $c3=$cgi->cookie(-name=>'afile'.$pid, -value=>"$afile", -expires=>'+120m');
  $c4=$cgi->cookie(-name=>'uid'.$pid, -value=>"$uid", -expires=>'+120m');
  $c5=$cgi->cookie(-name=>'sid'.$pid, -value=>"$sid", -expires=>'+120m');
  $c6=$cgi->cookie(-name=>'xid'.$pid, -value=>"$xid", -expires=>'+120m');
  $c7=$cgi->cookie(-name=>'finish'.$pid, -value=>'', -expires=>'-1d');
  $seeds=getQuestionSeeds($qfile,$maxQuizQuestions);
  $c8=$cgi->cookie(-name=>'seeds'.$pid, -value=>"$seeds", -expires=>'+120m');
  print $cgi->header(-cookie=>[$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8], -type=>'text/html');
}


sub deleteCookies {
my($cgi)=@_;
my($c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8);
  $c1=$cgi->cookie(-name=>'qfile'.$pid, -value=>'', -expires=>'-1d');
  $c2=$cgi->cookie(-name=>'sfile'.$pid, -value=>'', -expires=>'-1d');
  $c3=$cgi->cookie(-name=>'afile'.$pid, -value=>'', -expires=>'-1d');
  $c4=$cgi->cookie(-name=>'uid'.$pid, -value=>'', -expires=>'-1d');
  $c5=$cgi->cookie(-name=>'sid'.$pid, -value=>'', -expires=>'-1d');
  $c6=$cgi->cookie(-name=>'xid'.$pid, -value=>'', -expires=>'-1d');
  $c7=$cgi->cookie(-name=>'finish'.$pid, -value=>'', -expires=>'-1d');
  $c8=$cgi->cookie(-name=>'seeds'.$pid, -value=>'', -expires=>'-1d');
  return $cgi->header(-cookie=>[$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8], -type=>'text/html');
}


sub existCookies {
my($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile)=@_;  # same as setCookies()
my($c1,$c2,$c3,$c4,$c5,$c6);
  $c1=$cgi->cookie(-name=>'qfile'.$pid);
  $c2=$cgi->cookie(-name=>'sfile'.$pid);
  $c3=$cgi->cookie(-name=>'afile'.$pid);
  $c4=$cgi->cookie(-name=>'uid'.$pid);
  $c5=$cgi->cookie(-name=>'sid'.$pid);
  $c6=$cgi->cookie(-name=>'xid'.$pid);
  if("$c4" ne "" || "$c5" ne "" || "$c6" ne "" || "$c1" ne "" || "$c2" ne "" || "$c3" ne "") {
    return 1;
  }
  return 0;
}


sub quizStarted { #global: $quizDir
my($fname)=@_;
  $fname="$quizDir$fname";
  if(-e $fname) { return 1; }
  if(open(NILFILE,">$fname")) { close(NILFILE);}
  return 0;
}


sub getMarksText {
my($qfile,$sfile)=@_;
my(%state)=extractSolutions($qfile);
my($count)=getCount($qfile);
my(%student)=readState($sfile);
my($marks)=cmpState(\%state, \%student);
  if($marks>0) { return " <$marks/$count>"; }
  return "";
}


sub validatedQuery { # global: accessfile, $pid, $xid
local($cgi,*items,*cookies,$useCrypt)=@_;
my($uid,$sid,$key,$password,$delete,$qfile,$sfile,$afile,$msg);
my($admin,$name,$onoff);
  $uid=$items{'uid'};
  $password=$items{'password'};
  $delete=$items{'delete'};
  $sid=$items{'sid'};
  $key=$items{'key'};
  $admin=$items{'admin'};
  $onoff=$items{'onoff'};
  if("$admin" eq "yes") {
    $name=privilegedName($password);
    if("$name" ne "") {
      ($qfile,$sfile,$afile)=getFileNames($uid,$sid);
      if("$delete" eq "delete" && "$uid" ne "") {
        if(-e "$quizDir$sfile") {
          logEvent("$uid","$sid","deleted by $name". getMarksText($qfile,$sfile) );
          unlink "$quizDir$sfile";
        }
        print "content-type: text/html\n\n<html><body>\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location='${submiturlQuery}mode=logon&msg=Quiz+ready+to+restart+for+$uid.';\n"
         . "</script>\n";
        return 0;
      }
      elsif($items{'access'} eq "yes" && $onoff ne "") {
        if(setAccess($accessfile,$sid,$key,$onoff eq 'on',
		     isAdministrator($password))) {
          $msg="Session+$sid+is+now+$onoff.";
          logEvent("privileged","$sid","reset to $onoff by $name");
        }
        else {
          $msg="New+session+unauthorized.";
        }
        print "content-type: text/html\n\n<html><body>\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location='${submiturlQuery}mode=logon&msg=$msg';\n"
         . "</script>\n";
        return 0;
      }
      else {
        if(isAdministrator($password) && $delete ne 'delete') {
          if(! -e "$quizDir$qfile") {
            print "content-type: text/html\n\n<html><body>\n"
             . "<script language=javascript>\n"
             # . "top." #-> disallows framed quiz
             . "location='${submiturlQuery}mode=logon&msg=Session+$sid+unavailable.';\n"
             . "</script>\n";
            return 0;
          }
          if(-s "$quizDir$qfile" && ! -s "$quizDir$afile") {
            saveSolutions("$qfile","$afile");
          }
          print quizSolutions($qfile,$afile); return 0;
        }
      }
    }

    # wrongly tick administrator box
    print "content-type: text/html\n\n<html><body>\n"
       . "<script language=javascript>\n"
       # . "top." #-> disallows framed quiz
       . "location='${submiturlQuery}mode=logon&msg=Request+unauthorized.';\n"
       . "</script>\n";
    return 0;
  }

  if(passwordOk($uid,$password,$useCrypt)) {
    if(accessOk($accessfile,$sid,$key)) {
      ($qfile,$sfile,$afile)=getFileNames($uid,$sid);

      # allows quiz 'repeat' if no key is present
      if($allowQuizRepeats) {
        my($view,$repeat)=getSessionView($sid,$accessfile);
        if($items{'repeat'} eq "repeat" && ($key=~/^\s*$/ || $repeat)) {
          if(-e "$quizDir$sfile"
             && !existCookies($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile)) {
            logEvent("$uid","$sid","deleted by repeat". getMarksText($qfile,$sfile) );

            unlink "$quizDir$sfile";  # not logged in this case
          }
        }
      }

      if(! -s "$quizDir$qfile") { # shouldn't happen in general
        print "content-type: text/html\n\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location='${submiturlQuery}mode=logon&msg=Quiz+for+session+$sid+not+available.';\n"
         . "</script>\n";
        return 0;
      }

      if(-s "$quizDir$qfile" && ! -s "$quizDir$afile") { saveSolutions("$qfile","$afile"); }

      # not allowing people to access again
      if(quizStarted($sfile)
         && !($allowQuizRepeats && param('repeat') eq "repeat"
              && existCookies($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile)) ) {
        print "content-type: text/html\n\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location=\"${submiturlQuery}mode=logon&msg=Quiz+$sid+is+currently+running+or+already+completed+for+$uid.\";\n"
         . "</script>\n";
         return 0;
      }

      logEvent("$uid","$sid");
      if(existCookies($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile)) {

    if($secureQuizMode || $sid eq cookie('sid'.$pid)) {

        print "content-type: text/html\n\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location=\"${submiturlQuery}mode=logon&msg=SECURE+LOGOUT+first+for+$uid"
         . ("$pid" eq ""? "":" (pid:$pid)")
         . ".\";\n"
         . "</script>\n";
         return 0;

    } else {

        $submiturlQuery="$submiturl?pid=".generatePid()."&unitname=".escape($unitname)."&";

        print "content-type: text/html\n\n"
         . "<script language=javascript>\n"
         # . "top." #-> disallows framed quiz
         . "location=\"${submiturlQuery}mode=logon&msg=Must+use+a+PID+different+from+$pid.\";\n"
         . "</script>\n";
         return 0;

    }

      }

      setCookies($cgi,$uid,$sid,$xid,$qfile,$sfile,$afile);
      print "<script language=javascript>\n"
       # . "top." #-> disallows framed quiz
       . "location='${submiturlQuery}mode=frame&qfile=$qfile&sfile=$sfile&afile=$afile';\n"
       . "</script>\n";
      return 0;
    }
    else {
      $msg="Invalid+session+or+key.";
    }
  }

  if(!authenticated($cgi,\%items,\%cookies)) {
    if("$msg" eq "" && "$uid" ne "") { $msg="Invalid+user+or+password."; }
    print "content-type: text/html\n\n"
     . "<script language=javascript>\n"
     # . "top." #-> disallows framed quiz
     . "location='${submiturlQuery}mode=logon&msg=$msg';\n"
     . "</script>\n";
    return 0;
  }

  if(param('via') ne "") {
    $msg="duplicated session not allowed";
    print "content-type: text/html\n\n"
     . "<script language=javascript>\n"
     # . "top." #-> disallows framed quiz
     . "location='${submiturlQuery}mode=logon&msg=$msg';\n"
     . "</script>\n";
    return 0;
  }

  return 1;
}


sub logoutPage {
my($cgi)=@_;
  print deleteCookies($cgi);
  print "<script language=javascript>\n"
#   . "top.location.href='${submiturlQuery}mode=logon';\n"
   . " window.open('${submiturlQuery}mode=logon','','dependent=no,resizable,location,personalbar,scrollbars,menubar,status,titlebar,toolbar');\n"
   . "top.close();\n"
   . "</script>\n";
}


sub getSessions {
my($fname)=@_;
my(%session)=();
my($aline,$id,$value);
  if(open(SESSION,"<$fname")) {
    while(<SESSION>) {
      $aline=$_;
      if($aline=~/^([^\#]*)\#.*/) { $aline="$1";}
      ($id,$value)=split(" ",$aline,2);
      $value=~ s/\s*$//;
      $session{"$id"}="$value";
    }
    close(SESSION);
  }
  return %session;
}


sub getSessionMode {
local($key,*session)=@_;
my($mode,$password);
  $mode=$session{"$key"};
  $password="";
  if($mode=~/^([^,]*),(.*)$/) {
    $mode="$1";
    $password="$2";
  }
  return ($mode,$password);
}


sub accessOk {
my($fname,$key,$password)=@_;
my(%session)=getSessions($fname);
my($a,$b)=getSessionMode("$key",\%session);
  if("$a" ne "*") { return 0; }
  if("$b" eq "") { return 1; }
  if("$b" eq "$password") { return 1; }
  return 0;
}


sub logEvent {
my($uid,$sid,$message)=@_;
my($ip)=$clientinfo;
my($time)=time;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday)=localtime($time);
  $year=$year % 100;
  if($year<10) { $year="0$year"; }
  if(open(LOGFILE,">>$logfile")) {
    flock(LOGFILE, 2);
    print LOGFILE "$uid $sid,$ip,$mday/",$mon+1,"/$year,$hour:$min:$sec $message\n";
    flock(LOGFILE, 8);
    close(LOGFILE);
    chmod 0600, "$logfile";
  }
}


sub readStartTime {
my($fname)=@_;
my($start,$period)=(0,0);
my($clock);
  if(open(TIME, "<$quizDir/$fname")) {
    while(<TIME>) {
      if(/^0:(\d*),(\d+),(\d+),/) {
        $period=$1;
        $start=$2;
	$clock=$3;
        last;
      }
    }
    close(TIME);
  }
  return ($start,$clock,$period);
}


sub makeClock {
my($fname)=@_;
my($start,$clock,$period)=readStartTime($fname);
  if($period<=0 || $start<=1000000000 || isLocked($fname)) { return "<p>"; }
  $text="<form name=WATCH><font size=-2>TIME: </font><input type=text name=DISPLAY size=8></form>\n"
   . "<script language=javascript>\n"
   . "start=$clock; period=$period;\n"
   . "setInterval(\"document.WATCH.DISPLAY.value=timeLeft();\", 500);\n"
   . "function timeLeft() {\n"
   . "  time=Math.floor(period-(new Date().getTime()/1000-start));\n"
   . "  if(time<0) time=0;\n"
   . "  hour=Math.floor(time/3600);\n"
   . "  time=time-hour*3600;\n"
   . "  minute=Math.floor(time/60);\n"
   . "  second=time-minute*60;\n"
   . "  return \"\"+hour+\":\"+minute+\":\"+second;\n"
   . "}\n"
   . "</script>\n";
  return $text;
}

#### administrator's tools ####

sub renameFields { # $text already somewhat normalised
my($text,$num)=@_;
my($result,$property,$rest,$i);
my(@items);
  @items= split(/<input /, $text);
  for($i=1; $i<=$#items; $i++) {
    if($items[$i]=~ /^([^<>]*)>(.*)$/s) {
      $property=" $1 ";
      $rest="$2";
      $property=~ s/\s+name\s*=\s*\"(\S+)\"\s*/ name=\"$1_$num\" /gi;
      $items[$i]="$property>$rest";
    }
   }
  $result="";
  for($i=0; $i<=$#items; $i++) {
    if($i==0) { $result=$items[0]; next; }
    $result=$result . "<input " . $items[$i];
  }
  return $result;
}


sub quizSolutions { # for instructor only
my($qfile,$sfile)=@_;
my($total)=getCount($qfile);
my($content,$info,$type,$result,$qnum);
  for($qnum=1;$qnum<=$total;$qnum++) {
    ($content,$info)=getRawQuiz($qfile,$qnum);
    ($info)=readInfo($sfile,$qnum);
    $content=setInitValue($content,$info);
    $content=renameFields($content,$qnum);
    $result=$result
     # . "<p><font face='Arial, Helvetica, sans-serif' size=+2><b>$qnum.</b>&nbsp;</font>\n"
     . $content;
  }
  return "content-type: text/html\n\n<html><head><BASE href=\"$imageBase\"></head><body>\n".$result."</body></html>\n";
}


sub showSolutions {
my(%items)=@_;
my($qfile)=$items{'qfile'};
my($afile)=$items{'afile'};
  print quizSolutions($qfile,$afile);
}


sub rawRandomArray {
my($total,$length)=@_;
my(@list)=();
my($i);
#local($a,$b);
  for($i=0;$i<$total;$i++) {
	$list[$i]=$i+1;
  }
  for($i=0;$i<$length;$i++) {
	$n=int(rand($total));
	$a=$list[$i+$n];
	$list[$i+$n]=$list[$i];
	$list[$i]=$a;
	$total--;
  }
  @list=@list[0..($i-1)];
  return @list;
}


sub randomArray {
my($total,$length)=@_;
my(@list);
local($a,$b);
  @list=rawRandomArray($total,$length);;
  return sort {$a<=>$b} @list;
}


sub selectQuiz {
my($qfile,$length)=@_;
my($total)=getCount($qfile);
my(@list)=randomArray($total,$length);
my($content,$info,$result,$qnum,$count);
  $count=0;
  foreach $qnum (@list) {
    ($content,$info)=getRawQuiz($qfile,$qnum);
    if($content eq "") { next; } ### added: 23/03/2007
    $count++;
    $result=$result
     . "<!--quiz-$count-$info-->\n"
     . "<p><font face='Arial, Helvetica, sans-serif' size=+2><b>$count.</b>&nbsp;</font>\n"
     . $content;
  }
  return #command line usage
    "content-type: text/html\n\n<html><head><BASE href=\"$imageBase\"></head>\n<body>\n".
    $result."\n<!--quiz---->\n</body></html>\n";
}


sub verifyAdministrator {
my($pword);
  system "stty -echo";
  print STDERR "Password: ";
  chomp($pword = <STDIN>);
  print STDERR "\n";
  system "stty echo";
  return isAdministrator($pword);
}


sub fetchMarks { # global $quizDir
my($scale,$qfile,@others)=@_;
my(%state)=extractSolutions($qfile);
my($count)=getCount($qfile);
my(%student,$marks,$sfile,$uid,$sid,$uid0,$sid0,$aline);
  print "### MARKS FOR $qfile (full marks ", int($scale/0.1)*.1, ") ###\n\n";
  if($count<=0) { return; }
  $scale=$scale/$count;
  $quizDir="";
  $count=0;
  # expand filename if it starts with '@'
  my(@list)=();
  foreach $sfile (@others) {
    if($sfile=~/^\@(.*)$/) {
      if(open(FILELIST,"<$1")) {
        @list=(@list, <FILELIST>);
        close(FILELIST);
      }
    }
    else { @list=(@list, $sfile); }
  }
  @others=@list;
  foreach $sfile (@others) {
    %student=readState($sfile);
    $marks=int($scale * cmpState(\%state, \%student)/.1)*.1; #rounding
    $aline=$student{'0'};
    my $uidX=$sfile;     ### added: 7/04/2009 (for $uidX)
#    if($sfile=~/state_(\d+)\.(.*)$/) {
    if($sfile=~/state_([\d_a-zA-Z]+)\.(.*)$/) {
      $uidX=$uid0="$1";  ### updated: 7/04/2009
      $sid0="$2";
    }
    if($aline=~/:(\d*):([^:]*)\s*>\s*$/) {
      $uidX=$uid="$1";   ### updated: 7/04/2009
      $sid="$2";
    }
    $count++;
    print "$count\t$uidX\t [$marks] $sid <$uid0:$sid0>", ### updated: 7/04/2009
    ("$uid0" ne "$uid" || "$sid0" ne "$sid")? "?":"", "\n\n";
  }
}


sub setAccess {
my($file,$sid,$newkey,$enable,$isAdmin)=@_;
my(%access)=();
my(%passwords)=();
my(%info)=();
my($session,$mode,$key,$comment,$aline);
my($header)="";
  if(open(ACCESSIN, "<$file")) {
    while(<ACCESSIN>) {
      $aline=$_;
      if(/^\s*#/) { $header="$header$_"; next; }
      $session=$mode=$key=$comment="";
      $aline=~s/\n//g;
      if($aline=~/^([^#]*)#(.*)$/) {
        $comment="\t#$2";
        $aline="$1";
      }
      if($aline=~/^\s*(\S+)\s+(\S+)/) {
        $session="$1";
        $mode="$2";
      }
      elsif($aline=~/^\s*(\S+)/) {
        $session="$1";
      }
      if($session ne "") {
        if($mode=~/^([^,]*),(.*)$/) {
          $mode="$1";
          $key="$2";
        }
        $access{"$session"}="$mode";
        $passwords{"$session"}="$key";
        $info{"$session"}="$comment";
      }
    }
    close(ACCESSIN);
  }
  if(!$isAdmin && !defined($access{"$sid"})) { return 0; }
  if("$newkey" ne "") { $passwords{"$sid"}="$newkey"; }
  if($enable) { $access{"$sid"}="*"; } else { $access{"$sid"}=""; }
  if(!open(ACCESSOUT, ">$file")) { return 0; }
  flock(ACCESSOUT, LOCK_EX);
  print ACCESSOUT "$header\n";
  foreach $session (sort (keys %access)) {
    $key=$passwords{"$session"};
    if("$key" ne "") { $key=",$key"; }
    print ACCESSOUT "$session\t" . $access{"$session"}
      . "$key" . $info{"$session"} . "\n";
  }
  flock(ACCESSOUT, LOCK_UN);
  close(ACCESSOUT);
  return 1;
}


sub escape {
my($text)=@_;
  $text=~ s/([^a-zA-Z0-9])/sprintf('%%%x',ord($1))/eg;
  return $text;
}


################
# main program #
################



#$secureQuizMode=0;


# some fixed initialisations
$clientinfo=$ENV{'COMPUTERNAME'};  # MS's IIS only
$clientinfo="$clientinfo:".$ENV{'REMOTE_ADDR'};

# command line operations for quiz operator
if($#ARGV>=0) {
  $cmd=uc($0);
  $option=$ARGV[0];
  if($#ARGV==0 || $option eq "-h" ) {
    print "$cmd [ options ]\nversion 2.01 1/1/2012 Zhuhan Jiang\n -g quizBankFile numberOfQuestions unitAliasOrFullname\n -m totalMarks quizFile [@]stateFiles ...\n -p newPassword\nNil options means it is run as a CGI program,\n\@stateFile contains state filenames.\n";
    exit 0;
  }

  shift ARGV;
  if("$option" eq "-g") {
    # find proper $imageBase (not really important)
    my(@fullunitnames)=keys %unitmap;
    $unitalias=$ARGV[2];
    foreach my $key(@fullunitnames) {
      if("$unitalias" eq $unitmap{"$key"}) {
        $imageBase=$imagebasemap{"$key"};
        last;
      }
    }
    foreach my $key(@fullunitnames) {
      if($key=~/^\s*$unitalias/i || $unitmap{"$key"}=~/^\s*$unitalias/i) {
        $imageBase=$imagebasemap{"$key"};
        last;
      }
    }
    print STDERR "creating quizfile of $ARGV[1] questions from $ARGV[0] ...\n";
    if(!verifyAdministrator()) { exit 0; }
    print selectQuiz($ARGV[0], $ARGV[1]);
  }
  elsif("$option" eq "-p") {
    print "\$administrator=\"", quickCrypt($ARGV[0]), "\";\nin $0 makes \"$ARGV[0]\" the new password.\n";
  }
  else {
    print STDERR "fetching marks from state files ...\n";
    if(!verifyAdministrator()) { exit 0; }
    fetchMarks(@ARGV);
  }
  exit 0;
}


use CGI qw(:standard);
use CGI::Carp qw/fatalsToBrowser/;
# use MIME::Base64;

$cgi=new CGI;
$submiturl=$cgi->url();
#$submiturl="http://staff.cit.uws.edu.au/cgi-bin/cgiwrap/zhuhan/quiz-lynx.pl";

$unitname=param('unitname');

# update the dir/file location
$unitalias=$unitmap{ param('unitname') };
$quizDir=$quizdirmap{"$unitname"};
$imageBase=$imagebasemap{"$unitname"};
$passwordfile="${baseDir}${unitalias}_password.txt";
$accessfile="${quizDir}${unitalias}_access.txt";
$logfile="${quizDir}${unitalias}_logfile.txt";

# create states directory if not already in existence
if(! -d "$quizDir$stateDir") { mkdir "$quizDir$stateDir",0700; } ### added: 2/01/2009

if($secureQuizMode) {
  $pid='';
}
else {
  $pid=$cgi->param('pid');
  if("$pid"=~/^\s*$/) {
    while(1) {
      $pid=int(rand(100000000));
      $pid="$pid";
      if(length($cgi->cookie('uid'.$pid))<=0) { last; }
    }
  }
}

# generate a random x-window id (for each browser session)
$xid=$cgi->param('xid');
if("$xid"=~/^\s*$/) { $xid=randomKey(8); }
my $xidInCookie=cookie('xid'.$pid);
if($xidInCookie ne "" && $xidInCookie ne $xid) {
    $xid=$xidInCookie;
    $cgi->param(-name=>'xid', -default=>$xid);
}


%COOKIES=getCookies($cgi);  # uses $pid
%FORM=$cgi->Vars;           # %FORM=getParas();
$mode=$FORM{'mode'};


$clientinfo="$clientinfo:". $cgi->cookie('uid'.$pid);
$clientinfo="$clientinfo:". $cgi->cookie('sid'.$pid);

if($secureQuizMode) {
  $submiturlQuery="$submiturl?unitname=".escape($unitname)."&";
} else {
  $submiturlQuery="$submiturl?pid=$pid&unitname=".escape($unitname)."&";
}


# logon screen
if("$mode" eq "logon") {
  logonPage($cgi,\%FORM);
  exit 0;
}

if(!validatedQuery($cgi,\%FORM,\%COOKIES,$passwordcrypt)) {
  deleteCookies($cgi);
  exit 0;
}

if($mode eq "frame") {
  framePage(%FORM);
}
elsif($mode eq "list") {
  listQuiz(%FORM);
}
elsif($mode eq "finish") {
  markQuiz($cgi,\%FORM);
}
elsif($mode eq "run") {
  checkQuiz(%FORM);
}
elsif($mode eq "logout") {
  logoutPage($cgi);
}
else {
  print "content-type: text/html\n\n<html><body>\n"
   . "<script language=javascript>\n"
   # . "top." #-> disallows framed quiz
   . "location='${submiturlQuery}mode=logon';\n"
   . "</script>\n";
}

# showSolutions(%FORM); exit 0;




sub randomKey {
    my($num)=@_;
    my($n,$c,$i,$key);
    $key="";
    for($i=0; $i<$num; $i++) {
	$n=rand(52);
	if($n<26) {
	    $c=chr(ord('A')+$n);
	} else {
	    $c=chr(ord('a')+$n-26);
	}
	$key .= $c;
    }
    return $key;
}


sub generatePid {
my($pid);
  while(1) {
    $pid=int(rand(100000000));
    $pid="$pid";
    if(length(cookie('uid'.$pid))<=0) { last; }
  }
  return $pid;
}
