#!/usr/bin/perl

#---------------------------------------------
# (c) Zhuhan Jiang
#     version 1.16  26 Feb 2009 (renamed 2.01)
# Freeware under GNU copyright convention.
#---------------------------------------------

######################
# configuration
######################

# external configuration file
$externConfig="_conf-b.rc";

# where password file and config file are kept
# $baseDir="c:/iwd2002/webquiz/";
$baseDir="./";

# files this program is meant to read or create/update
$fileForStudentIDs="_namelist.txt";
$fileForPasswords="_password.txt";
$fileForRawPasswords="_rawpassword.txt";
$fileForHttpPasswords="_htpassword.txt";
$fileForHttpGroups="_htgroup.txt";

# map unitname into a single word which is to become the prefix
# of password files;
# also works if %unitmap=();
%unitmap=(
# 'Interactive Website Development', 'IWSD',
# 'Internet Computing', 'IC',
);


# change next line to make a new password for the administrator;
# use "webquiz.pl -p MyPassWord" to create a new string,
# or simply use $administrator=quickCrypt('MyPassWord');
$administrator="eC3Se5iK4JoAw";    # "administrator"
#$administrator=quickCrypt("administrator");

# add names/passwords to those who are allowed reset student passwords,
# $administrator will be added automatically
%privileged=(
'privileged', "/iLDz6DgBhOIA",     # pswd="priviledged"
# 'zhuhan', quickCrypt('zjiang')   # more of the same
);

# save raw passwords?
$saveRawPasswords=0;    # 1=save passwords for setting up user accounts elsewhere

# save http access file for Apache web server?
$saveHttpAccessPasswords=1;

# unit/purpose/duedate data
# *[*] <UNITNAME>, <UNITDIR>
# **=default unit
#
$cfgtext=<<EOF_UNITS_AND_DUEDATES

* Interactive Website Development , IWSD
#** Internet Computing , IC   # **=default

EOF_UNITS_AND_DUEDATES
;


######################################
# don't change anything below
# unless you know what you are doing
######################################

#include configuration file
do "${baseDir}$externConfig";

# fetch unit/purpose/duedates info
@cfgarray=split(/\n/,$cfgtext);


sub trim {
my($s)=@_;
  if($s=~/^\s*(.*\S)\s*$/) { return "$1"; }
  return "$s";
}

$defaultUnitCount=0;   # remember the selection
$defaultUnitName="";

sub parseCfg { # global: $defaultUnitCount, $defaultUnitName
my(@cfg)=@_;
my($data)=[];
my($count,$subcount)=(0,0);
my($title,$alias)=("","");
my($aline,$name,$due,$late);
my($entry)=[];
my($titlecount)=-1;
  foreach $aline(@cfg) {
    $name=$dir=$due=$late="";
    if($aline=~/^([^#]*)#.*$/) {
      $aline="$1";
    }
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^(.*)$/) { $aline="$1"; }
    $aline=~tr/a-zA-Z0-9[](){}<>+\-*\/,.:!?@#$%^&= /_/cs;
    if($aline=~/^([^,]*),(.*)$/) {
      $name="$1"; $aline="$2";
      if($aline=~/^([^,]*),(.*)$/) {
        $dir="$1";  $aline="$2";
        if($aline=~/^([^,]*),(.*)$/) {
          $due="$1";  $aline="$2";
          if($aline=~/^([^,]*),(.*)$/) {
            $late="$1";  $aline="$2";
          } else { $late=$aline; }
        } else { $due=$aline; }
      } else { $dir=$aline; }
    } else { $name=$aline; }
    $name=trim($name);
    $dir=trim($dir);
    $due=trim($due);
    $late=trim($late);
    if($name=~/^\*+\s*(.*)$/) {
      $aline="$1";
      $titlecount++;
      if($name=~/^\*\*/) {
        $defaultUnitCount=$titlecount;
        $defaultUnitName=$aline;
      }
      # $name="$1";
      $name=$aline;
      if($title ne "") {
        $data->[$count++]=[$title,$alias,$entry];
      }
      $title=$name; $alias=$dir;
      $subcount=0;
      $entry=[];
    }
    else {
      $entry->[$subcount++]=[$name,$dir,$due,$late];
    }
  }
  if($#cfg>=0) { $data->[$count++]=[$title,$alias,$entry]; }
  return $data;
}


sub cvtCfg{ # global: $defaultUnitCount
my($data,$unit)=@_;
my($i,$j,$name,$entry);
my(%unitmap)=();
my(%purposemap)=();
my(%duedate)=();
my(%latedate)=();
  $i=0;
  if(!defined($unit)) { $unit=""; }
  while(1) {
    $entry=$data->[$i];
    if(!defined($entry)) { last; }
    $name=$entry->[0];
    $unitmap{"$name"}=$entry->[1];
    if("$name" eq "$unit" || $i==$defaultUnitCount && "$unit" eq "") {
      $entry=$entry->[2];
      $j=0;
      while(1) {
        if(!defined($entry->[$j])) { last; }
        $name=$entry->[$j][0];
        $purposemap{"$name"}=$entry->[$j][1];
        $duedate{"$name"}=$entry->[$j][2];
        $latedate{"$name"}=$entry->[$j][3];
        $j++;
      }
    }
    $i++;
  }
  return (\%unitmap,\%purposemap,\%duedate,\%latedate);
}


# get %unitmap
@cfgParsed=parseCfg(@cfgarray);
if(param('unitname') eq "") {
  param(-name=>'unitname',-default=>$defaultUnitName);
}
(*unitmap)=cvtCfg(@cfgParsed,param('unitname'));


#(*tmpmap)=cvtCfg(parseCfg(@cfgarray),param('unitname'));
#@tmpkeys=keys %tmpmap;
#if($#tmpkeys>=0) { *unitmap=\%tmpmap; }
adjustUnitmap(\%unitmap);


# add "$baseDir" to each unit dir
sub adjustUnitmap {
local(*unitmap)=@_;
my($key);
  for $key (keys %unitmap) {
    $unitmap{$key}="$baseDir" . $unitmap{$key};
  }
}



# you probably don't need to modify these
$privileged{'administrator'}=$administrator;


sub isAdministrator { # global: $administrator
my($password)=@_;
  if(crypt($password,$administrator) eq "$administrator") {
    return 1;
  }
  return 0;
}


sub privilegedName { # global %privileged
my($password)=@_;
my($key,$value);
  foreach $key (keys %privileged) {
    $value=$privileged{"$key"};
    if(crypt($password,$value) eq "$value") {
      return "$key";
    }
  }
  return "";
}


use MIME::Base64;
use CGI qw(:standard);
use CGI::Carp qw/fatalsToBrowser/;

# URL of this submission program
$submitURL=url();

sub validStudentId {
my($file,$id)=@_;
my($aline);
my($success)=0;
  #open(STUDENTID, $file) || die "fail to open $file";
  if(!open(STUDENTID, $file)) { return 0; }
  flock(STUDENTID,2);  #2=LOCK_EX
  while(<STUDENTID>) {
    $aline=$_;
    # remove comments and empty lines
    if($aline=~/^([^\#]*)\#.*$/) { $aline="$1";}
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^\s*([^\s,]+).*$/ && "$id" eq "$1") {
      $success=1;
      last;
    }
  }
  flock(STUDENTID,8);  #8=LOCK_UN
  close(STUDENTID);
  return $success;
}


sub updateIdFile {
my($delete,$file,$id,$info)=@_;
my($aline,$success,$mode,$key,$exist);
my(%ids)=();
  $mode=(-e "$file")? "<":">";
  if(!open(IDFILE,"+".$mode."$file")) { return 0; }
  flock(IDFILE,2);  #2=LOCK_EX
  while(<IDFILE>) {
    $aline=$_;
    # remove comments and empty lines
    if($aline=~/^([^\#]*)\#.*$/) { $aline="$1";}
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^\s*([^\s,]+)(.*)$/) {
      $ids{"$1"}="$2";
    }
  }
  $exist=defined($ids{"$id"});
  if($exist && !$delete || !$exist && $delete) { return -1; }
  $ids{"$id"}="$info";
  if($delete) { undef $ids{"$id"}; }
  $success=seek(IDFILE,0,0);
  foreach $key (sort(keys %ids)) {
    if(defined($ids{"$key"})) {
      print IDFILE "$key" . $ids{"$key"} . "\n";
    }
  }
  $success &&= truncate(IDFILE,tell(IDFILE));
  flock(IDFILE,8);  #8=LOCK_UN
  $success &&= close(IDFILE);
  return $success;
}


sub loadExtraFile {
my($file,$delimiter)=@_;
my(%passwords)=();
my($aline);
  #open(PASSWORDIN, $file) || die "fail to open $file";
  if(!open(PASSWORDIN, $file)) { return %passwords; }
  flock(PASSWORDIN,2);  #2=LOCK_EX
  while(<PASSWORDIN>) {
    $aline=$_;
    # remove comments and empty lines
    if($aline=~/^([^\#]*)\#.*$/) { $aline="$1";}
    if($aline=~/^\s*$/) { next; }
    if("$delimiter" eq "") {  # for the case of htgroup
      if($aline=~/^\s*([^\s].*)$/) { $passwords{"$1"}=""; }
    }
    elsif($aline=~/^\s*([^\s${delimiter}]+)${delimiter}(.*)$/) {
      $passwords{"$1"}="$2";
    }
  }
  flock(PASSWORDIN,8);  #8=LOCK_UN
  close(PASSWORDIN);
  return %passwords;
}


sub saveExtraFile {
local($file,$delimiter,*passwords)=@_;
  #open(PASSWORDOUT, ">$file") || die "fail to open $file";
  if(!open(PASSWORDOUT, ">$file")) { return 0; }
  flock(PASSWORDOUT,2);  #2=LOCK_EX
  foreach $key (sort(keys %passwords)) {
    if(defined($passwords{"$key"})) {
      print PASSWORDOUT "$key$delimiter" . $passwords{"$key"} . "\n";
    }
  }
  flock(PASSWORDOUT,8);  #8=LOCK_UN
  close(PASSWORDOUT);
  return 1;
}


sub updateExtraFile {
# $task: 0=update if not already there, 1=force update, -1=delete
my($overwrite,$task,$file,$delimiter,$id,$info)=@_;
my(%passwords)=();
  if(!$overwrite) { %passwords=loadExtraFile($file,$delimiter); }
  $passwords{"$id"}="$info";
  if($task<0) { undef $passwords{"$id"}; }
  return saveExtraFile($file,$delimiter,\%passwords);
}


sub quickCrypt {
my($password)=@_;
my($set,$length,$salt);
  $set="ABCDEFGHIJKLMNOPQRSTUVWXYZ./0123456789";
  $set=$set.lc(substr($set,0,26));
  $length=length($set);
  $salt= substr($set,rand($length),1).substr($set,rand($length),1);
  return crypt($password,$salt);
}


sub duplicatedAccount {
local(*passwords)=@_;
my(@info,$item,$next,$i);
  @info= values % passwords;
  for($i=0; $i<=$#info; $i++) {
    $item=$info[$i];
    if($item=~/^[^,]*,([^,]+),.*$/) {
      $info[$i]="$1";
    }
    elsif($item=~/^[^,]*,([^,]+)\s*$/) {
      $info[$i]="$1";
    }
  }
  @info=sort(@info);
  $item=","; #impossible value
  for($i=0; $i<=$#info; $i++) {
    $next=$info[$i];
    # print "[$next]";
    if($item eq $next) {
      return "Account $item already present: please modify suffix";
    }
    $item=$next;
  }
  return "";
}


sub updatePasswords {
# $task: 0=no overwrite, 1=overwrite (force), -1=delete
local($task,*passwords,$id,$info)=@_;
  if($id=~/^\s*(.*)\s*$/) { $id="$1"; }
  if(defined($passwords{"$id"}) && !$task) {
    return "ID $id already registered";
  }
  if($task<0 && !defined($passwords{"$id"})) {
    return "ID $id not registered anyway";
  }
  $passwords{"$id"}="$info";
  if($task<0) { undef $passwords{"$id"}; }
  return duplicatedAccount(\%passwords);
}


sub rawRegister {
my($idfile,$passwordfile,$rawpassfile,$httppassfile,$httpgroupfile,$task)=@_;
my($studentid)=param('studentid');
my($password)=param('password');
my($accountname)=param('accountname');
my($create,$mode,$info,$msg,$aline,$key,$success,$htpasswd);
my(%passwords)=();
  if($accountname!~ /^[a-zA-Z0-9_]+$/
     || !validStudentId($idfile,$studentid) ) {
     return "Invalid ID $studentid or ID file";
  }
  $create= !(-e "$passwordfile");
  $mode= $create?">":"<";
  if(!open(PASSWORDFILE,"+".$mode."$passwordfile")) {
    return "Fail to open $passwordfile";
  }
  flock(PASSWORDFILE,2);  #2=LOCK_EX
  while(<PASSWORDFILE>) {
    $aline=$_;
    # remove comments and empty lines
    if($aline=~/^([^\#]*)\#.*$/) { $aline="$1";}
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^\s*([^\s,]+),(.*)$/) {
      $passwords{"$1"}="$2";
    }
  }
  $htpasswd=quickCrypt($password);
  $info= "$htpasswd,$accountname,"
    . uc(param('familyname')) . " " . ucfirst(param('givenname'));
  $msg=updatePasswords($task,\%passwords,$studentid,$info);
  if($msg) {
    flock(PASSWORDFILE,8);  #8=LOCK_UN
    close(PASSWORDFILE);
    chmod 0600, $passwordfile; # added on 2/07/2008
    return $msg;
  }
  $success=seek(PASSWORDFILE,0,0);
  foreach $key (sort(keys %passwords)) {
    if(defined($passwords{"$key"})) {
      print PASSWORDFILE "$key," . $passwords{"$key"} . "\n";
    }
  }
  $success &&= truncate(PASSWORDFILE,tell(PASSWORDFILE));
  flock(PASSWORDFILE,8);  #8=LOCK_UN
  $success &&= close(PASSWORDFILE);

  #update other password files
  if($success && $saveRawPasswords) {
    my($encoded)="$accountname,". encode_base64($password);
    if($encoded=~/^(.*)\n$/){ $encoded="$1"; }
    updateExtraFile($create,$task,$rawpassfile,",",$studentid, #"$accountname,$password");
      $encoded);
    chmod 0600, $rawpassfile;
  }

  #update http-access (.htaccess) password files
  if($success && $saveHttpAccessPasswords) {
    updateExtraFile($create,$task,$httppassfile,":",$studentid,"$htpasswd");
    updateExtraFile($create,$task,$httpgroupfile,"","student: $studentid","");
  }

  return $success?"":"Fail to write $passwordfile";
}


sub register {
my($task)=@_;
my($unitname)=param('unitname');
my($unitdir)=$unitmap{"$unitname"};
my($idfile,$passwordfile,$rawpassfile,$httppassfile,$httpgroupfile);
  $idfile=$unitdir.$fileForStudentIDs;
  $passwordfile=$unitdir.$fileForPasswords;
  $rawpassfile=$unitdir.$fileForRawPasswords;
  $httppassfile=$unitdir.$fileForHttpPasswords;
  $httpgroupfile=$unitdir.$fileForHttpGroups;
  return rawRegister($idfile,$passwordfile,$rawpassfile,$httppassfile,$httpgroupfile,$task);
}


sub registerPage {
my($msg)=param('msg');
my($key,$count);

  print <<EOF_REGISTERPAGE
content-type: text/html

<html>

<script language=javascript>
<!--
function formAccount() {
var name="",s,r,ob=document.REG;
  r=new RegExp("[^a-zA-Z0-9]","g");
  s=ob.familyname.value.toLowerCase().replace(r,"_");
  if(s!="") name+= "_"+ s.substr(0,6);
  s=ob.givenname.value.toLowerCase().replace(r,"_");
  if(s!="") name+= "_"+ s.substr(0,1);
  s=ob.suffix.value.toLowerCase().replace(r,"_");
  if(s!="") name+= "_"+ s.substr(0,5);
  name=name.replace(/_+/g, "_");
  name=name.replace(/_+\$/, "");
  ob.accountname.value=name;
  return name!="";
}


function validated(obj) {
var ob;
  if(!obj.studentid.value.match(/[a-z0-9]/i)) {
    ob=obj.studentid;
    ob.value="ID please";
    ob.focus();
    ob.select();
    return false;
  }
  if(formAccount()) {
    if(obj.password.value==obj.passwordagain.value
       && obj.password.value.length>0
       || obj.admin.checked) {
       return true;
    }
    ob=obj.password;
    if(ob.value.length==0 && obj.passwordagain.value.length>0) ob=obj.passwordagain;
    ob.focus();
    ob.select();
    return false;
  }
  ob=obj.familyname;
  ob.value="name please";
  ob.focus();
  ob.select();
  return false;
}
//-->
</script>

EOF_REGISTERPAGE
;


  print "<body><form name=REG action=\"$submitURL\" method=post ENCTYPE=\"multipart/form-data\" onsubmit=\"return validated(this);\">\n"
   . "<table cellpadding=30 bgcolor=" . $mainBackgroundColor . "><tr><td>\n"
   . "<input type=hidden name=mode value=''>\n"
   . "<table border=0>\n"
   . "<tr><td colspan=2 align=center><font face='Arial, Helvetica, sans-serif' size=+3><b>REGISTRATION</b></font></td></tr>\n"
   . "<tr><td>&nbsp;</td></tr>\n";


  print "<tr><td align=right>UNIT NAME:&nbsp;\n<select name=\"unitname\">\n";
  if(param('unitname') ne "") {
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if( "$key" eq param('unitname') ) { print " selected "; }
        print ">$key\n";
    }
  } else { # no explict request
    $count=0;
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if($count++==$defaultUnitCount) { print " selected "; }
        print ">$key\n";
    }
  }
  print "</select>\n</td><td width=40>&nbsp; </td></tr>\n";


  print
  "\n<tr><td align=right>STUDENT ID:&nbsp;",
    textfield('studentid','',30,30),
    "&nbsp;</td><td width=40>&nbsp; </td></tr>",
  "\n<tr><td align=right>FAMILY NAME:&nbsp;",
    textfield(-name=>'familyname', -default=>'',-size=>30,-maxlength=>30,
              -onchange=>'formAccount();'),
    "&nbsp;</td><td width=40>&nbsp; </td></tr>",
  "\n<tr><td align=right>GIVEN NAME:&nbsp;",
    textfield(-name=>'givenname', -default=>'',-size=>30,-maxlength=>30,
              -onchange=>'formAccount();'),
    "&nbsp;</td><td width=40>&nbsp; </td></tr>",
  "\n<tr><td align=right>SELECT PASSWORD:&nbsp;",
    password_field(-name=>'password', -value=>'',-size=>30,-maxlength=>30),
    "&nbsp;</td><td width=40>&nbsp;* </td></tr>",
  "\n<tr><td align=right>PASSWORD AGAIN:&nbsp;",
    password_field(-name=>'passwordagain', -value=>'',-size=>30,-maxlength=>30),
    "&nbsp;</td><td width=40>&nbsp;* </td></tr>",
  "\n<tr><td align=right>ACCOUNT NAME:&nbsp;",
    textfield(-name=>'accountname', -default=>'',-size=>30,-maxlength=>30,
              -title=>'auto-generated field: never use this as your User Name, use your student ID instead',
              -onfocus=>'blur();document.REG.suffix.focus();'),
    "&nbsp;</td><td width=40>&nbsp; </td></tr>",
  "\n<tr><td align=right align=right>MODIFY ACCOUNT SUFFIX:&nbsp;",
    textfield(-name=>'suffix', -default=>'', -size=>8, -maxlength=>10,
              -title=>'use this when you have the same name and initial as another person',
              -onchange=>'formAccount();'),
    "&nbsp;</td></tr>",
  "\n<tr><td align=right><fieldset style=\"padding-bottom:1pt;padding-right:0pt;padding-top:0pt;\" title=\"this section is for administrators only: others please ignore\"><legend><font size=-3 style=\"font-variant: small-caps;\">&nbsp; Admin Only &nbsp;</font></legend><font size=-2>ADMINISTRATOR</font>",
    checkbox(-name=>'admin', -value=>'yes', -label=>' '),
    "&nbsp;<font size=-2>REMOVE REG</font>",
    checkbox(-name=>'remove', -value=>'remove', -label=>' '),
    "&nbsp; &nbsp;<font size=-2><i>ID</i> </font>",
    checkbox(-name=>'add', -value=>'add', -label=>': '),
    "<font size=-2><i>ADD</i></font><input type=radio name=onoff value=on>",
    "<font size=-2><i>DEL</i></font><input type=radio name=onoff value=off>",
    "&nbsp;</fieldset></td></tr>",
  "\n<tr><td align=right>",
    "<input type=button name=logout onclick=\"if(self==top)window.open('$submitURL');top.close();\" value=\"secure logout\">&nbsp;",
    "<input type=submit name=submit value=\"register\"></td></tr>",
  "\n<tr><td align=right>ver 2.01 &copy; <font size=-2>2012 ZHUHAN JIANG</font></td></tr>";

 if($msg!~/^\s*$/) {
   if($msg=~/^<!([^\s]+)>/) {
     print "\n<tr></tr><td>&nbsp;</td><tr><td bgcolor=$1 colspan=2 align=center><font color=white>$msg</font></td></tr>\n";
   }
   else {
     print "\n<tr></tr><td>&nbsp;</td><tr><td bgcolor=red colspan=2 align=center><font color=white>$msg</font></td></tr>\n";
   }
 }

 print "</table>\n"
   . "</td></tr></table>\n"
   . "</form>\n</body></html>\n";
}


sub privilegedTasks {
my($password,$admin,$remove,$add);
my($name,$msg);
  $password=param('password');
  param(-name=>'password', -value=>'');
  $admin=param('admin');
  $remove=param('remove');
  $add=param('add');
  $onoff=param('onoff');
  $studentid=param('studentid');
  if("$admin" eq "yes") {
    if("$add" eq "add") {
      if(isAdministrator($password)) {
        if("$onoff" eq "on" || "$onoff" eq "off") {
          my($unitname)=param('unitname');
          my($unitdir)=$unitmap{"$unitname"};
          my($idfile)=$unitdir.$fileForStudentIDs;
          my($status)=updateIdFile( ("$onoff" eq "off"), $idfile,$studentid,
            " ".uc(param('familyname'))." ". ucfirst(param('givenname')));
          if($status>0) {
            return "ID $studentid ". (($onoff eq "off")?"removed":"added");
          }
          elsif($status<0) {
            return "ID $studentid already " .(($onoff eq "off")?"absent":"there");
          }
          else {
            return "Add or remove ID $studentid failed";
          }
        }
      }
      elsif("$onoff" eq "on" || "$onoff" eq "off") {
        return "Invalid adminstrator password";
      }
    }
    $name=privilegedName($password);
    if("$name" ne "" && "$remove" eq "remove") {
      $msg=register(-1);
      if($msg) { return $msg; }
      return "$studentid's registration now removed";
    }
    if("$name" ne "" && "$remove" ne "remove") { # && "$add" ne "add") {
      return "No admin tasks performed";
    }
    if("$name" eq "") {
      return "Invalid privileged password";
    }
  }
  return "";
}


sub dispatcher {
my($admin)=param('admin');
my($msg);
  if("$admin" eq "yes") {
    $msg=privilegedTasks();
    param(-name=>'msg', -value=>"$msg");
  }
  else {
    $msg=register(0);
    if($msg) {
      if(param('accountname')) { param(-name=>'msg', -value=>"$msg"); }
    }
    else {
      $msg="<!blue>".param('studentid')
           . " now registered as <b>" . param('accountname') ."</b>";
      param(-name=>'msg', -value=>"$msg");
      param(-name=>'password', -value=>'');
      param(-name=>'passwordagain', -value=>'');
    }
  }
  registerPage();
}


dispatcher();
