#!/usr/bin/perl

   %allnames=();
   %allmarks=();
   %alldata=();

   $fullmarks=0;

   if($#ARGV < 0) {
     print "useage:  $0 [-r] [-n] [-m] filenames\n";
     print "         -r  display via ranks\n";
     print "         -n  display via names\n";
     print "         -m  display via marks\n";
     print "file format:\
#...full marks<spaces>FULLMARKS...\
...<tab>STUDENTID<tab>...[MARKS]...\
";
     exit;
   }

   while (<@ARGV>) {

   if("$_" eq "-r") { $showViaRanks=1; next; }
   if("$_" eq "-n") { $showViaNames=1; next; }
   if("$_" eq "-m") { $showViaMarks=1; next; }

      open(FILE, "<$_") || next ;
      while(<FILE>) {
        $line=$_;

        # get full marks from the line "#... full marks dddd ..."
        if($line=~/\#.*full marks\s+(\d+)/) { $fullmarks+=$1; }

        if($line=~/^[^\t]*\t\s*(\d+)\s*\t(.*)$/) {
          $id="$1";
          $name=$rest="$2";
          $mark=0;

          if($rest=~/^(.*)\[(.*)\].*$/) {
             $name="$1";
             $mark=0+eval($2);
          }

          if($name=~/^(.*),\s*$/) { $name="$1"; }
          if($name=~/^(.*\S)\s*$/) { $name="$1"; }
          $allnames{"$id"}="$name";
          $allmarks{"$id"} += $mark;
          $alldata{"$id"} .="+$mark";
        }
      }
      close(FILE);
   }

   sub numorder { $allmarks{$b} <=> $allmarks{$a}; }
   sub strorder { $allnames{$a} cmp $allnames{$b}; }

   $count=0;
   %rawranks=();
   @allkeys= sort numorder keys(%allnames);
   foreach $key (@allkeys) {
      $rawranks{$key}=$count++;
   }

   %ranks=();
   for($i=0; $i<=$#allkeys; ) {
     $init=$i;
     $value=$allmarks{$allkeys[$i]};
     for($j=$init; $j<=$#allkeys; $j++) {
       $newvalue=$allmarks{$allkeys[$j]};
       if($newvalue != $value) { last; }
     }
     $i=$j;
     for($j=$init; $j<$i; $j++) {
       $start=$init+1;
       $ranks{$allkeys[$j]}= ($start==$i? "$start" : "$start-$i");
     }
   }

   if(!$showViaNames && !$showViaMarks) { $showViaRanks=1; }
   if($showViaRanks) { &printRanks; }
   if($showViaNames) { &printViaNames; }
   if($showViaMarks) { &printViaMarks; }


sub printRanks {
   if($fullmarks == 0) { $fullmarks=100; }
   print "### RANKING IN MARKS (id, rank, name, marks, breakdown) ###\n\n";
   foreach $key (@allkeys) {
      $count=$ranks{$key};
      $name=$allnames{$key};
      $mark=$allmarks{$key};
      $data=$alldata{$key};
      $percent=$mark/$fullmarks *100;
      print "$count\t$key\t";
      $mark=sprintf("%.2f",$mark); ### updated: 13/04/2009
      write STDOUT; # $name\t$mark\t$data\n";
      print "\n";
   }
}

sub printViaNames {
   print "\n### SORTED BY NAMES ###\n";
   $count=0;
   foreach $key (sort strorder keys(%allnames)) {
      $count++;
      $name=$allnames{$key};
      $mark=$allmarks{$key};
      $data=$alldata{$key};
      $percent=$mark/$fullmarks *100;
      $mark=sprintf("%.2f",$mark); ### updated: 13/04/2009
      write;
   }
}

sub printViaMarks {
   print "\n### SORTED BY MARKS ###\n";
   $count=0;
   foreach $key (sort numorder keys(%allnames)) {
      $count++;
      $name=$allnames{$key};
      $mark=$allmarks{$key};
      $data=$alldata{$key};
      $percent=$mark/$fullmarks *100;
      $mark=sprintf("%.2f",$mark); ### updated: 13/04/2009
      write;
   }
}

format STDOUT =
@<<<<<<< @##.#%   @<<<<<<<<<<<<<< @<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$count, $percent, $name, "[$mark]", "=$data"
.
