#!/usr/bin/perl
#
# display all non-record messages
# display selected records with (un-) matched digital student ID
# student ID may be terminated by space or ","

sub loadIds {
local($file)=@_;
local($line,$sid);
  if(!open(FILE,"$file")) { return ; }
  while(<FILE>) {
    $line=$_;
    $sid="";
    if($idFileNumbered) {
	if($line=~/^\s*\d+\s+(\d+)\D.*$/) {
	    $sid="$1";
	}
    } elsif($line=~/^\s*(\d+)\D.*$/) {
	$sid="$1";
    }
    if($sid=~/^\d+$/) {
	$ids[$#ids+1]=$sid;
    }
  }
  close(FILE);
}


sub isSelected {
local($sid)=@_;
local($i);
  for $i(@ids) {
    if("$i" eq "$sid") { return 1; }
  }
  return 0;
}


sub filter {
local($line,$sid);
  while(<STDIN>) {
    $line=$_;

    $sid="";
    if($inputNumbered) {
	if($line=~/^\s*\d+\s+(\d+)\D.*$/) {
	    $sid="$1";
	}
    } elsif($line=~/^\s*(\d+)\D.*$/) {
	$sid="$1";
    }
    if($sid=~/^\d+$/) {
      if($reverse) {
	  if(isSelected($sid)) { next; }
      } else {
	  if(!isSelected($sid)) { next; }
      }
    }
    print $line;
  }
}


if($#ARGV<0) {
  $program=$0;
  if($program=~/^.*\/([^\/]+)$/) { $program="$1"; }
  print "useage:  $program [-r] allowedIdFiles < input > output\n";
  print "         -r   reverse role to select non-allowed Ids\n";
  print "         -a   allowed ID format: <NUM> <ID> ..\n";
  print "         -i   input format:      <NUM> <ID> ..\n";
  print "              default format:    <ID> ..\n";
  exit 0;
}


@ids=();
$idFileNumbered=$inputNumbered=$reverse=0;
while (<@ARGV>) {
    if("$_" eq "-r") { $reverse=1; next; }
    if("$_" eq "-i") { $inputNumbered=1; next; }
    if("$_" eq "-a") { $idFileNumbered=1; next; }
    loadIds($_);
}

filter();

