#!/usr/bin/perl

#---------------------------------------------
# (c) Zhuhan Jiang
#     version 1.13  12 July 2007 (renamed 2.01)
# Freeware under GNU copyright convention.
#---------------------------------------------

############################################
# configurations: you may need to modify them
#############################################

$platformWebUrl="https://platformwebstaff.uws.edu.au";
$externConfig="_conf-b.rc";

%currentDeliveries=(
   'DDD' => '2011 SP 300104',
   'PF' =>  '2011 AU 300580',
   'VNS' => '2011 SP 300001'
);


# where password file and config file are kept
# $baseDir="c:/iwd2002/webquiz/";
$baseDir="./";


###################################
# no modifications required below
# unless you know what you are doing
####################################


#include configuration file
do "${baseDir}$externConfig";

# fetch unit/purpose/duedates info
@cfgarray=split(/\n/,$cfgtext);


# used perl modules
use CGI qw(:standard);
use LWP::UserAgent;


sub trim {
my($s)=@_;
  if($s=~/^\s*(.*\S)\s*$/) { return "$1"; }
  return "$s";
}


$defaultUnitCount=0;
$defaultUnitName="";

sub parseCfgX { # global: $defaultUnitCount, $defaultUnitName
my(@cfg)=@_;
my($data)=[];
my($count,$subcount)=(0,0);
my($title,$alias,$quizwhere,$imagewhere)=("","","","");
my($aline,$name,$due,$late);
my($entry)=[];
my($titlecount)=-1;
  foreach $aline(@cfg) {
    $name=$dir=$due=$late="";
    if($aline=~/^([^#]*)#.*$/) {
      $aline="$1";
    }
    if($aline=~/^\s*$/) { next; }
    if($aline=~/^(.*)$/) { $aline="$1"; }
    $aline=~tr/a-zA-Z0-9[](){}<>+\-*\/,.:!?@#$%^&= ~/_/cs;
    if($aline=~/^([^,]*),(.*)$/) {
      $name="$1"; $aline="$2";
      if($aline=~/^([^,]*),(.*)$/) {
        $dir="$1";  $aline="$2";
        if($aline=~/^([^,]*),(.*)$/) {
          $due="$1";  $aline="$2";
          if($aline=~/^([^,]*),(.*)$/) {
            $late="$1";  $aline="$2";
          } else { $late=$aline; }
        } else { $due=$aline; }
      } else { $dir=$aline; }
    } else { $name=$aline; }
    $name=trim($name);
    $dir=trim($dir);
    $due=trim($due);
    $late=trim($late);
    if($name=~/^\*+\s*(.*)$/) {
      $aline="$1";
      $titlecount++;
      if($name=~/^\*\*/) {
        $defaultUnitCount=$titlecount;
        $defaultUnitName=$aline;
      }
      # $name="$1";
      $name=$aline;
      if($title ne "") {
        $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere];
      }
      $title=$name; $alias=$dir;
      $quizwhere=$due; $imagewhere=$late;
      $subcount=0;
      $entry=[];
    }
    else {
      $entry->[$subcount++]=[$name,$dir,$due,$late];
    }
  }
  if($#cfg>=0) { $data->[$count++]=[$title,$alias,$entry,$quizwhere,$imagewhere]; }
  return $data;
}


sub cvtCfgX{ # global: $defaultUnitCount
my($data,$unit)=@_;
my($i,$j,$name,$entry);
my(%unitmap)=();
my(%purposemap)=();
my(%duedate)=();
my(%latedate)=();
my(%quizdirmap)=();
my(%imagebasemap)=();
  $i=0;
  if(!defined($unit)) { $unit=""; }
  while(1) {
    $entry=$data->[$i];
    if(!defined($entry)) { last; }
    $name=$entry->[0];
    $unitmap{"$name"}=$entry->[1];
    $quizdirmap{"$name"}=$entry->[3];
    $imagebasemap{"$name"}=$entry->[4];
    if("$name" eq "$unit" || $i==$defaultUnitCount && "$unit" eq "") {
      $entry=$entry->[2];
      $j=0;
      while(1) {
        if(!defined($entry->[$j])) { last; }
        $name=$entry->[$j][0];
        $purposemap{"$name"}=$entry->[$j][1];
        $duedate{"$name"}=$entry->[$j][2];
        $latedate{"$name"}=$entry->[$j][3];
        $j++;
      }
    }
    $i++;
  }
  return (\%unitmap,\%quizdirmap,\%imagebasemap,\%purposemap,\%duedate,\%latedate);
}



# get %unitmap etc
@cfgXParsed=parseCfgX(@cfgarray);
if(param('unitname') eq "") {
  param(-name=>'unitname',-default=>$defaultUnitName);
}
(*unitmap,*quizdirmap,*imagebasemap,*purposemap,*duedate,*latedate)=cvtCfgX(@cfgXParsed,param('unitname'));


if(!urlOk($platformWebUrl)) {
    print "content-type:text/html\n\n",
    "ABORTED: currently not able to access $platformWebUrl";
    exit 0;
}


# URL of this submission program
$submitURL=url();
submitPage();



sub submitPage { # $defaultUnitCount: global variable
my($msg)=param('msg');
my($key,$count,$shortname,$outputfile);

  print header()
   . "<body><form name=SUBMIT action=\"$submitURL\" method=post ENCTYPE=\"multipart/form-data\">\n"
   . "<table cellpadding=30 bgcolor=" . $mainBackgroundColor . "><tr><td>\n"
   . "<input type=hidden name=mode>\n"
   . "<table border=0>\n"
   . "<tr><td colspan=2 align=center><font face='Arial, Helvetica, sans-serif' size=+3><b>&nbsp;PRAC ENROLMENT UPDATE&nbsp; </b></font></td></tr>\n"
   . "<tr><td>&nbsp;</td></tr>\n";

  print "<tr><td align=right>UNIT NAME:&nbsp;\n<select name=\"unitname\" onchange=\"document.SUBMIT.submit();\">\n";

  if(param('unitname') ne "") {
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if( "$key" eq param('unitname') ) { print " selected "; }
        print ">$key\n";
    }
  } else { # no explict request
    $count=0;
    foreach $key (sort keys(%unitmap)) {
      print "<option value=\"$key\"";
        if($count++==$defaultUnitCount) { print " selected "; }
        print ">$key\n";
    }
  }

  print "</select>\n</td><td width=40>&nbsp; </td></tr>\n";

  $shortname=$unitmap{param('unitname')};

  if(param('mode') eq 'yes') {

    $deliveryParameter=$currentDeliveries{$shortname};
    if($deliveryParameter ne "") {

	`/usr/bin/perl traverse.pl -t $deliveryParameter | /usr/bin/uniq -w 20 > $cgiscriptdir/config/$shortname$fileForTutsRegistry`;
#	`rm $cgiscriptdir/config/$shortname$fileForTutsRegistry 2>/dev/null; cp -p $cgiscriptdir/config/$shortname$fileForTutsRegistry.guests $cgiscriptdir/config/$shortname$fileForTutsRegistry 2>/dev/null; echo >> $cgiscriptdir/config/$shortname$fileForTutsRegistry`;
#	`/usr/bin/perl traverse.pl -t 2007 AU 300155 | /usr/bin/uniq -w 20 >> $cgiscriptdir/config/$shortname$fileForTutsRegistry`;

    }
}

$outputfile="config/$shortname$fileForTutsRegistry";
my $x=`ls -l $outputfile 2>/dev/null`;
if($x=~/^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/) {
    $x="$6 $7 $8";
} else { $x="none"; }
print "\n<tr><td align=right>records last updated at <i><b><span _style=\"background:#60c0c0;color:black;\">",
$x, "</span><b></i>",
"</td></tr>";

  print
  "\n<tr><td align=right>",
    "<input type=submit value=\"update enrolment records\" onclick=\"document.SUBMIT.mode.value='yes';\"></td></tr>",

  "\n<tr><td align=right>ver 2.01 &copy; <font size=-2> 2012 ZHUHAN JIANG</font></td></tr>";

 if($msg!~/^\s*$/) {
   if($msg=~/^<!([^\s]+)>/) {
     print "\n<tr></tr><td>&nbsp;</td><tr><td bgcolor=$1 colspan=2 align=center><font color=white>$msg</font></td></tr>\n";
   }
   else {
     print "\n<tr></tr><td>&nbsp;</td><tr><td bgcolor=red colspan=2 align=center><font color=white>$msg</font></td></tr>\n";
   }
 }

 print "</table>\n"
   . "</td></tr></table>\n"
   . "</form>\n</body></html>\n";

 $msg=param('filereceipt');
 if($msg!~/^\s*$/) {
   print "<script language=javascript>\n<!--\n",
   "document.SUBMIT.receipt.value+=\"".param('filereceipt')."\\n\";",
   "\n//-->\n</script>\n";
 }

 if(param('unitname') eq "") {
   param(-name=>'unitname',-default=>(sort keys(%unitmap))[$defaultUnitCount]);
 }
 if(param('purpose') eq "") {
   param(-name=>'purpose',-default=>(sort keys(%purposemap))[0]);
 }

}


sub urlOk {
my($url)=@_;
my($ua,$req,$res);

  $ua=LWP::UserAgent->new;
  $req=HTTP::Request->new(GET => "$url");
  $res=$ua->request($req);
  return $res->is_success;
}

