# execute this script to get helps
#
# format of _password.txt file:
# 12345678,J/b883Xq7O2YI,_familyname_z,FAMILYNAME Zhuhan
# ....
#

$passfile="../../PF_password.txt";

if($#ARGV < 0) {
  print "USAGE:   $0 passwordfile\n";
  print "  eg.    $0 $passfile < textfile\n";
  exit;
}

$passfile=$ARGV[0];
$sourcedir=$ARGV[1];
$targetdir=$ARGV[2];

print STDERR "DOING $0 $passfile $sourcedir $targetdir\n";

%name2id=();

if(open(PASSFILE,"<$passfile")) {
    while(<PASSFILE>) {
	$aline="$_";
	if($aline=~ /^([^,]*),[^,]*,([^,]*),/) {
	    $id="$1";
	    $user="$2";
	    $name2id{$user}=$id;
	}
    }
    close(PASSFILE);
}

while(<STDIN>) {
    $user="$_";
    if($user=~ /^\s*(\S+)\s*$/) {
	$user="$1";
    }
    $id=$name2id{$user};
    print "$id $user\n";
}
