# execute this script to get helps
#
# format of _password.txt file:
# 12345678,J/b883Xq7O2YI,_familyname_z,FAMILYNAME Zhuhan
# ....
#

$passfile="../../PF_password.txt";
$sourcedir="assign1";
$targetdir="assign1a";

if($#ARGV < 2) {
  print "USAGE:   $0 passwordfile sourcedir targetdir\n";
  print "  eg.    $0 $passfile $sourcedir $targetdir\n";
  print "---------\
EXAMPLE: create from\
  $sourcedir/
  $sourcedir/_familyname_z\
  $sourcedir/_morenames_i\
the new directories (auto-made)\
  $targetdir/\
  $targetdir/12345678_familyname_z\
  $targetdir/87654321_morenames_i\
";
  exit;
}

$passfile=$ARGV[0];
$sourcedir=$ARGV[1];
$targetdir=$ARGV[2];

print STDERR "DOING $0 $passfile $sourcedir $targetdir\n";
print  "\nmkdir -p $targetdir\n";

%name2id=();

if(open(PASSFILE,"<$passfile")) {
    while(<PASSFILE>) {
	$aline="$_";
	if($aline=~ /^([^,]*),[^,]*,([^,]*),/) {
	    $id="$1";
	    $user="$2";
	    $name2id{$user}=$id;
	}
    }
}

print "\
cd $targetdir\
if test \$\? -eq 0\
then\
\
";

foreach $key (keys (%name2id)) {
    print "ln -s ../$sourcedir/$key  ", $name2id{$key}, $key, "\n";
}

print "\
cd ..\
fi\
";

