#!/bin/sh

# purpose: search a zip file to see if it contains all the keywords
#          in regular expression format
# output:  display the zip filename if for each keyword at least one
#          file in the zipfile contains the keyword
# exit:    1=not successful
# author:  Zhuhan Jiang
# proceure:
#  sh multiple-egrep.sh zipfile keyword1 keyword2 ...
#

zipfile="$1";
shift

while [ $# -gt 0 ]
do

  /usr/bin/unzip -c "$zipfile" | grep -E "$1" >/dev/null

  if [ $? -gt 0 ] ; then
    exit 1;
  fi;

  shift
done  

echo $zipfile
