#!/usr/bin/perl
#
# 1. create all marks file by
#    perl rescale.pl -m *.marks > all_marks.txt
# 2. create tabulated entries by
#    perl tabulatemarks.pl *.marks < all_marks.txt > tabbed_all_marks.txt
# 3. load tabbed_all_marks.txt to EXCEL spreadsheets
#

if($#ARGV < 0) {
    print "USAGE:  $0 marksfiles < inputfile\n";
    print "        marksfiles are all the assessment names in the inputfile\n";
    exit;
}


sub locate {
my($text,$key)=@_;
  if($text=~/\+$key\:([^\+]*)/) {
    return "$1";
  }
  return "0.00";
}


@data=<STDIN>;
$count=0;


print "\t\t\t";
for($i=0; $i<=$#ARGV; $i++) {
  print "\t", $ARGV[$i];
}
print "\n\n";


for($n=0; $n<=$#data; $n++) {
    $aline=$data[$n];
    if($aline=~/^(.*\S)\s*(\[.*)$/) { # insert tab in front of [..]
	$aline="$1\t$2";
    }
    if($aline=~/^(.*)$/) { $aline="$1"; }
    print $aline;
    $text="";
    if($aline=~/=([^=]*)$/) {
	$text="$1";
    }

    for($i=0; $i<=$#ARGV; $i++) {
	print "\t", locate($text,$ARGV[$i]);
    }
    print "\n";
}

