$movefiles=$ARGV[0];
$program=$0;

$user=$ENV{'USER'};
$tmpdir="/tmp";

if($user eq "") {
    print "Abort: env parameter \$USER is not set.\n";
    exit 0;
}

print "** configuring for the new user $user ..\n";
$success=1;
$inputfile1="menu-buttons.html";
$outfile1="${tmpdir}/${user}_${inputfile1}";
$inputfile1="vns2011/menu-buttons.html";
$success &&= convertFile($inputfile1,$outfile1,'zhuhan',$user);

$inputfile2="schedule.html";
$outfile2="${tmpdir}/${user}_${inputfile2}";
$inputfile2="vns2011/schedule.html";
$success &&= convertFile($inputfile2,$outfile2,'zhuhan',$user);

$inputfile3="index-frames.html";
$outfile3="${tmpdir}/${user}_${inputfile3}";
$inputfile3="vns2011/index-frames.html";
$success &&= convertFile($inputfile3,$outfile3,'zhuhan',$user);

$inputfile4="_conf-b.rc";
$outfile4="${tmpdir}/${user}_${inputfile4}";
$inputfile4="cgi-bin/suite/$inputfile4";
$success &&= convertFile($inputfile4,$outfile4,"\"zhuhan\"","\"$user\"");


print "\n** checking permissions for main subdirectories ..\n";
@dirs=( '.', '..',
'cgi-bin', 'cgi-bin/suite', 'cgi-bin/suite/config',
'cgi-bin/forum', 'cgi-bin/forum/images',
'vns2011', 'courses',
'vns2011/webquiz', 'vns2011/webquiz/images', 'vns2011/assignments',
'vns2011/htpasswd', 'vns2011/lectures', 'vns2011/tutorials', 'vns2011/solutions');
checkMultiPermissions('drwx..x..x','-d',@dirs);

@dirs=('cgi-bin/suite/support', 'cgi-bin/suite/HTML',
'cgi-bin/suite/digits', 'cgi-bin/forum/data',
'cgi-bin/log', 'tools', 'vns2011/webquiz/states', 'vns2011/marks');
checkMultiPermissions('drwx......','-d',@dirs);

@files=('cgi-bin/suite/tri_gn.gif', 'cgi-bin/suite/tri_rd.gif');
checkMultiPermissions('.rw.r..r..','',@files);


if($success) {
    if($movefiles eq "movefiles") {
	print "\n** moving reconfigured files ..\n";
	`mv $outfile1 $inputfile1`;
	print "$outfile1 moved to $inputfile1\n";
	`mv $outfile2 $inputfile2`;
	print "$outfile2 moved to $inputfile2\n";
	`mv $outfile3 $inputfile3`;
	print "$outfile3 moved to $inputfile3\n";
	`mv $outfile4 $inputfile4`;
	print "$outfile4 moved to $inputfile4\n";
        `chmod a+r $inputfile1 $inputfile2 $inputfile3`;
    } else {
	print "\n** manually mv the files:\n";
	print "mv $outfile1 $inputfile1\n";
	print "mv $outfile2 $inputfile2\n";
	print "mv $outfile3 $inputfile3\n";
	print "mv $outfile4 $inputfile4\n";
	print "\n** execute \"perl $program movefiles\" to move the above 4 files automatically.\n";
    }
}


sub convertFile {
    my($inputfile,$outfile,$source,$target)=@_;
    my $doneOnce=0;
    my $success=0;
    if(open(INFILE,"<$inputfile")) {
	if(open(OUTFILE,">${outfile}")) {
	while(<INFILE>) {
	    $line=$_;
	    if(!$doneOnce) {
		if($line=~ s/$source/$target/) {
		    $doneOnce=1;
		}
	    }
	    print OUTFILE $line;
	}
	close(OUTFILE);
	$success=1;
	print "created $outfile from $inputfile\n";
        }
	close(INFILE);
    }
    return $success;
}


sub checkMultiPermissions {
    my ($permission,$dirflag,@dirs)=@_;
    while(<@dirs>) {
	$dir=$_;
	$status=checkPermission($dir,$permission,$dirflag);
        print "$dir -> ",
          ($status>0? 'ok':'not sufficient'),
          ($status>1? ' .. may be too much':''), "\n";
    }
}

sub checkPermission {
    my($dir,$permission,$dirflag)=@_;
    my $mode=`ls -l $dirflag $dir`;
    my $status=0;
    if($mode=~/^${permission}/) {
	$status=1;
	$mode=substr($mode,0,10);
	$permission=~ s/\./\-/g;
	if($permission ne $mode) {
	    $status=2;
	}
    }
    return $status;
}

